/* Indicator.c generated by valac 0.56.17, the Vala compiler
 * generated from Indicator.vala, do not modify */

/*
* Copyright 2015-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "sound.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <libnotify/notify.h>
#include <float.h>
#include <math.h>
#include <canberra.h>
#include <wingpanel.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <pulse/pulseaudio.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <locale.h>
#include <canberra-gtk.h>
#include <gmodule.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SOUND_INDICATOR_0_PROPERTY,
	SOUND_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY,
	SOUND_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY,
	SOUND_INDICATOR_VOLUME_STEP_PROPERTY,
	SOUND_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* sound_indicator_properties[SOUND_INDICATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _ca_proplist_destroy0(var) ((var == NULL) ? NULL : (var = (ca_proplist_destroy (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _SoundIndicatorPrivate {
	gboolean _natural_scroll_touchpad;
	gboolean _natural_scroll_mouse;
	gint _volume_step;
	DisplayWidget* display_widget;
	GtkBox* main_box;
	SoundWidgetsPlayerList* mpris;
	SoundWidgetsScale* volume_scale;
	SoundWidgetsScale* mic_scale;
	SoundWidgetsDeviceManagerWidget* output_device_manager;
	SoundWidgetsDeviceManagerWidget* input_device_manager;
	GtkSeparator* mic_separator;
	NotifyNotification* notification;
	SoundServicesVolumeControlPulse* volume_control;
	gboolean open;
	gboolean mute_blocks_sound;
	guint sound_was_blocked_timeout_id;
	gdouble max_volume;
	ca_context* ca_context;
	gdouble total_x_delta;
	gdouble total_y_delta;
	guint notify_timeout_id;
};

struct _Block1Data {
	int _ref_count_;
	SoundIndicator* self;
	gboolean is_mic;
};

static gint SoundIndicator_private_offset;
static gpointer sound_indicator_parent_class = NULL;
GSettings* sound_indicator_settings = NULL;

static void sound_indicator_set_max_volume (SoundIndicator* self);
static void sound_indicator_on_volume_change (SoundIndicator* self);
static const gchar* sound_indicator_get_volume_icon (SoundIndicator* self,
                                              gdouble volume);
static void sound_indicator_on_mic_volume_change (SoundIndicator* self);
static void sound_indicator_on_mute_change (SoundIndicator* self);
static void sound_indicator_on_mic_mute_change (SoundIndicator* self);
static void sound_indicator_on_is_playing_change (SoundIndicator* self);
static gboolean ____lambda56_ (SoundIndicator* self);
static gboolean _____lambda56__gsource_func (gpointer self);
static void sound_indicator_on_volume_icon_scroll_event (SoundIndicator* self,
                                                  GdkEventScroll* e);
static gboolean sound_indicator_handle_scroll_event (SoundIndicator* self,
                                              GdkEventScroll* e,
                                              gdouble* dir);
static void sound_indicator_handle_change (SoundIndicator* self,
                                    gdouble change,
                                    gboolean is_mic);
static void sound_indicator_on_mic_icon_scroll_event (SoundIndicator* self,
                                               GdkEventScroll* e);
static void sound_indicator_update_mic_visibility (SoundIndicator* self);
static void sound_indicator_on_volume_switch_change (SoundIndicator* self);
static void sound_indicator_on_mic_switch_change (SoundIndicator* self);
static GtkWidget* sound_indicator_real_get_display_widget (WingpanelIndicator* base);
static GtkWidget* sound_indicator_real_get_widget (WingpanelIndicator* base);
static void _sound_indicator_on_mic_switch_change_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static void ___lambda58_ (SoundIndicator* self);
static void ____lambda58__gtk_range_value_changed (GtkRange* _sender,
                                            gpointer self);
static gboolean ___lambda59_ (SoundIndicator* self);
static void sound_indicator_notify_change (SoundIndicator* self,
                                    gboolean is_mic);
static gboolean ____lambda59__gtk_widget_button_release_event (GtkWidget* _sender,
                                                        GdkEventButton* event,
                                                        gpointer self);
static gboolean ___lambda60_ (SoundIndicator* self,
                       GdkEventScroll* e);
static gboolean ____lambda60__gtk_widget_scroll_event (GtkWidget* _sender,
                                                GdkEventScroll* event,
                                                gpointer self);
static void ___lambda61_ (SoundIndicator* self);
static void ____lambda61__sound_widgets_player_list_close (SoundWidgetsPlayerList* _sender,
                                                    gpointer self);
static void ___lambda62_ (SoundIndicator* self);
static void sound_indicator_show_settings (SoundIndicator* self);
static void ____lambda62__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void ___lambda63_ (SoundIndicator* self);
static void ____lambda63__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static gboolean ___lambda64_ (SoundIndicator* self,
                       GdkEventButton* e);
static gboolean ____lambda64__gtk_widget_button_release_event (GtkWidget* _sender,
                                                        GdkEventButton* event,
                                                        gpointer self);
static gboolean ___lambda65_ (SoundIndicator* self,
                       GdkEventScroll* e);
static gboolean ____lambda65__gtk_widget_scroll_event (GtkWidget* _sender,
                                                GdkEventScroll* event,
                                                gpointer self);
static void _sound_indicator_on_volume_switch_change_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self);
static void ___lambda66_ (SoundIndicator* self);
static void ____lambda66__gtk_range_value_changed (GtkRange* _sender,
                                            gpointer self);
static void sound_indicator_real_opened (WingpanelIndicator* base);
static void sound_indicator_real_closed (WingpanelIndicator* base);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda57_ (Block1Data* _data1_);
static gboolean sound_indicator_show_notification (SoundIndicator* self,
                                            gboolean is_mic);
static gboolean ___lambda57__gsource_func (gpointer self);
static void sound_indicator_update_tooltip (SoundIndicator* self);
static GObject * sound_indicator_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _sound_indicator_on_volume_change_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static void _sound_indicator_on_mic_volume_change_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static void _sound_indicator_on_mute_change_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void _sound_indicator_on_mic_mute_change_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _sound_indicator_on_is_playing_change_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static void _sound_indicator_update_mic_visibility_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void _sound_indicator_update_tooltip_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void _sound_indicator_set_max_volume_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void _sound_indicator___lambda67_ (SoundIndicator* self,
                                   GdkEventButton* e);
static void __sound_indicator___lambda67__display_widget_volume_press_event (DisplayWidget* _sender,
                                                                      GdkEventButton* e,
                                                                      gpointer self);
static void _sound_indicator___lambda68_ (SoundIndicator* self,
                                   GdkEventButton* e);
static void __sound_indicator___lambda68__display_widget_mic_press_event (DisplayWidget* _sender,
                                                                   GdkEventButton* e,
                                                                   gpointer self);
static void _sound_indicator_on_volume_icon_scroll_event_display_widget_volume_scroll_event (DisplayWidget* _sender,
                                                                                      GdkEventScroll* e,
                                                                                      gpointer self);
static void _sound_indicator_on_mic_icon_scroll_event_display_widget_mic_scroll_event (DisplayWidget* _sender,
                                                                                GdkEventScroll* e,
                                                                                gpointer self);
static void sound_indicator_finalize (GObject * obj);
static GType sound_indicator_get_type_once (void);
static void _vala_sound_indicator_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_sound_indicator_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
sound_indicator_get_instance_private (SoundIndicator* self)
{
	return G_STRUCT_MEMBER_P (self, SoundIndicator_private_offset);
}

SoundIndicator*
sound_indicator_construct (GType object_type)
{
	SoundIndicator * self = NULL;
#line 49 "../src/Indicator.vala"
	self = (SoundIndicator*) g_object_new (object_type, "code-name", WINGPANEL_INDICATOR_SOUND, NULL);
#line 48 "../src/Indicator.vala"
	return self;
#line 246 "Indicator.c"
}

SoundIndicator*
sound_indicator_new (void)
{
#line 48 "../src/Indicator.vala"
	return sound_indicator_construct (SOUND_TYPE_INDICATOR);
#line 254 "Indicator.c"
}

static void
sound_indicator_set_max_volume (SoundIndicator* self)
{
	gdouble max = 0.0;
	GSettings* _tmp0_;
	gdouble cap_volume = 0.0;
#line 140 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 141 "../src/Indicator.vala"
	_tmp0_ = sound_indicator_settings;
#line 141 "../src/Indicator.vala"
	max = g_settings_get_double (_tmp0_, "max-volume") / 100;
#line 143 "../src/Indicator.vala"
	cap_volume = ((gdouble) pa_sw_volume_from_dB (11.0)) / PA_VOLUME_NORM;
#line 144 "../src/Indicator.vala"
	if (max > cap_volume) {
#line 145 "../src/Indicator.vala"
		max = cap_volume;
#line 275 "Indicator.c"
	}
#line 148 "../src/Indicator.vala"
	self->priv->max_volume = max;
#line 149 "../src/Indicator.vala"
	sound_indicator_on_volume_change (self);
#line 281 "Indicator.c"
}

static void
sound_indicator_on_volume_change (SoundIndicator* self)
{
	gdouble volume = 0.0;
	SoundServicesVolumeControlPulse* _tmp0_;
	SoundServicesVolumeControlVolume* _tmp1_;
	SoundServicesVolumeControlVolume* _tmp2_;
	SoundWidgetsScale* _tmp3_;
	GtkScale* _tmp4_;
	GtkScale* _tmp5_;
#line 152 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 153 "../src/Indicator.vala"
	_tmp0_ = self->priv->volume_control;
#line 153 "../src/Indicator.vala"
	_tmp1_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp0_);
#line 153 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 153 "../src/Indicator.vala"
	volume = _tmp2_->volume / self->priv->max_volume;
#line 154 "../src/Indicator.vala"
	_tmp3_ = self->priv->volume_scale;
#line 154 "../src/Indicator.vala"
	_tmp4_ = sound_widgets_scale_get_scale_widget (_tmp3_);
#line 154 "../src/Indicator.vala"
	_tmp5_ = _tmp4_;
#line 154 "../src/Indicator.vala"
	if (volume != gtk_range_get_value ((GtkRange*) _tmp5_)) {
#line 312 "Indicator.c"
		SoundWidgetsScale* _tmp6_;
		GtkScale* _tmp7_;
		GtkScale* _tmp8_;
		DisplayWidget* _tmp9_;
		const gchar* _tmp10_;
#line 155 "../src/Indicator.vala"
		_tmp6_ = self->priv->volume_scale;
#line 155 "../src/Indicator.vala"
		_tmp7_ = sound_widgets_scale_get_scale_widget (_tmp6_);
#line 155 "../src/Indicator.vala"
		_tmp8_ = _tmp7_;
#line 155 "../src/Indicator.vala"
		gtk_range_set_value ((GtkRange*) _tmp8_, volume);
#line 156 "../src/Indicator.vala"
		_tmp9_ = self->priv->display_widget;
#line 156 "../src/Indicator.vala"
		_tmp10_ = sound_indicator_get_volume_icon (self, volume);
#line 156 "../src/Indicator.vala"
		display_widget_set_icon_name (_tmp9_, _tmp10_);
#line 332 "Indicator.c"
	}
}

static void
sound_indicator_on_mic_volume_change (SoundIndicator* self)
{
	gdouble volume = 0.0;
	SoundServicesVolumeControlPulse* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	SoundWidgetsScale* _tmp3_;
	GtkScale* _tmp4_;
	GtkScale* _tmp5_;
#line 160 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 161 "../src/Indicator.vala"
	_tmp0_ = self->priv->volume_control;
#line 161 "../src/Indicator.vala"
	_tmp1_ = sound_services_volume_control_get_mic_volume ((SoundServicesVolumeControl*) _tmp0_);
#line 161 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 161 "../src/Indicator.vala"
	volume = _tmp2_;
#line 163 "../src/Indicator.vala"
	_tmp3_ = self->priv->mic_scale;
#line 163 "../src/Indicator.vala"
	_tmp4_ = sound_widgets_scale_get_scale_widget (_tmp3_);
#line 163 "../src/Indicator.vala"
	_tmp5_ = _tmp4_;
#line 163 "../src/Indicator.vala"
	if (volume != gtk_range_get_value ((GtkRange*) _tmp5_)) {
#line 364 "Indicator.c"
		SoundWidgetsScale* _tmp6_;
		GtkScale* _tmp7_;
		GtkScale* _tmp8_;
#line 164 "../src/Indicator.vala"
		_tmp6_ = self->priv->mic_scale;
#line 164 "../src/Indicator.vala"
		_tmp7_ = sound_widgets_scale_get_scale_widget (_tmp6_);
#line 164 "../src/Indicator.vala"
		_tmp8_ = _tmp7_;
#line 164 "../src/Indicator.vala"
		gtk_range_set_value ((GtkRange*) _tmp8_, volume);
#line 376 "Indicator.c"
	}
}

static void
sound_indicator_on_mute_change (SoundIndicator* self)
{
	SoundWidgetsScale* _tmp0_;
	SoundServicesVolumeControlPulse* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gchar* volume_icon = NULL;
	SoundServicesVolumeControlPulse* _tmp4_;
	SoundServicesVolumeControlVolume* _tmp5_;
	SoundServicesVolumeControlVolume* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	DisplayWidget* _tmp9_;
	const gchar* _tmp10_;
	SoundServicesVolumeControlPulse* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
#line 168 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/Indicator.vala"
	_tmp0_ = self->priv->volume_scale;
#line 169 "../src/Indicator.vala"
	_tmp1_ = self->priv->volume_control;
#line 169 "../src/Indicator.vala"
	_tmp2_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp1_);
#line 169 "../src/Indicator.vala"
	_tmp3_ = _tmp2_;
#line 169 "../src/Indicator.vala"
	sound_widgets_scale_set_active (_tmp0_, !_tmp3_);
#line 171 "../src/Indicator.vala"
	_tmp4_ = self->priv->volume_control;
#line 171 "../src/Indicator.vala"
	_tmp5_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp4_);
#line 171 "../src/Indicator.vala"
	_tmp6_ = _tmp5_;
#line 171 "../src/Indicator.vala"
	_tmp7_ = sound_indicator_get_volume_icon (self, _tmp6_->volume);
#line 171 "../src/Indicator.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 171 "../src/Indicator.vala"
	volume_icon = _tmp8_;
#line 172 "../src/Indicator.vala"
	_tmp9_ = self->priv->display_widget;
#line 172 "../src/Indicator.vala"
	_tmp10_ = volume_icon;
#line 172 "../src/Indicator.vala"
	display_widget_set_icon_name (_tmp9_, _tmp10_);
#line 174 "../src/Indicator.vala"
	_tmp11_ = self->priv->volume_control;
#line 174 "../src/Indicator.vala"
	_tmp12_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp11_);
#line 174 "../src/Indicator.vala"
	_tmp13_ = _tmp12_;
#line 174 "../src/Indicator.vala"
	if (_tmp13_) {
#line 436 "Indicator.c"
		SoundWidgetsScale* _tmp14_;
#line 175 "../src/Indicator.vala"
		_tmp14_ = self->priv->volume_scale;
#line 175 "../src/Indicator.vala"
		sound_widgets_scale_set_icon (_tmp14_, "audio-volume-muted-symbolic");
#line 442 "Indicator.c"
	} else {
		SoundWidgetsScale* _tmp15_;
		const gchar* _tmp16_;
#line 177 "../src/Indicator.vala"
		_tmp15_ = self->priv->volume_scale;
#line 177 "../src/Indicator.vala"
		_tmp16_ = volume_icon;
#line 177 "../src/Indicator.vala"
		sound_widgets_scale_set_icon (_tmp15_, _tmp16_);
#line 452 "Indicator.c"
	}
#line 168 "../src/Indicator.vala"
	_g_free0 (volume_icon);
#line 456 "Indicator.c"
}

static void
sound_indicator_on_mic_mute_change (SoundIndicator* self)
{
	SoundWidgetsScale* _tmp0_;
	SoundServicesVolumeControlPulse* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	DisplayWidget* _tmp4_;
	SoundServicesVolumeControlPulse* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	SoundServicesVolumeControlPulse* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
#line 181 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 182 "../src/Indicator.vala"
	_tmp0_ = self->priv->mic_scale;
#line 182 "../src/Indicator.vala"
	_tmp1_ = self->priv->volume_control;
#line 182 "../src/Indicator.vala"
	_tmp2_ = sound_services_volume_control_pulse_get_micMute (_tmp1_);
#line 182 "../src/Indicator.vala"
	_tmp3_ = _tmp2_;
#line 182 "../src/Indicator.vala"
	sound_widgets_scale_set_active (_tmp0_, !_tmp3_);
#line 183 "../src/Indicator.vala"
	_tmp4_ = self->priv->display_widget;
#line 183 "../src/Indicator.vala"
	_tmp5_ = self->priv->volume_control;
#line 183 "../src/Indicator.vala"
	_tmp6_ = sound_services_volume_control_pulse_get_micMute (_tmp5_);
#line 183 "../src/Indicator.vala"
	_tmp7_ = _tmp6_;
#line 183 "../src/Indicator.vala"
	display_widget_set_mic_muted (_tmp4_, _tmp7_);
#line 185 "../src/Indicator.vala"
	_tmp8_ = self->priv->volume_control;
#line 185 "../src/Indicator.vala"
	_tmp9_ = sound_services_volume_control_pulse_get_micMute (_tmp8_);
#line 185 "../src/Indicator.vala"
	_tmp10_ = _tmp9_;
#line 185 "../src/Indicator.vala"
	if (_tmp10_) {
#line 503 "Indicator.c"
		SoundWidgetsScale* _tmp11_;
#line 186 "../src/Indicator.vala"
		_tmp11_ = self->priv->mic_scale;
#line 186 "../src/Indicator.vala"
		sound_widgets_scale_set_icon (_tmp11_, "indicator-microphone-muted-symbolic");
#line 509 "Indicator.c"
	} else {
		SoundWidgetsScale* _tmp12_;
#line 188 "../src/Indicator.vala"
		_tmp12_ = self->priv->mic_scale;
#line 188 "../src/Indicator.vala"
		sound_widgets_scale_set_icon (_tmp12_, "indicator-microphone-symbolic");
#line 516 "Indicator.c"
	}
}

static gboolean
____lambda56_ (SoundIndicator* self)
{
	DisplayWidget* _tmp0_;
	SoundServicesVolumeControlPulse* _tmp1_;
	SoundServicesVolumeControlVolume* _tmp2_;
	SoundServicesVolumeControlVolume* _tmp3_;
	const gchar* _tmp4_;
	gboolean result;
#line 206 "../src/Indicator.vala"
	self->priv->mute_blocks_sound = FALSE;
#line 207 "../src/Indicator.vala"
	self->priv->sound_was_blocked_timeout_id = (guint) 0;
#line 208 "../src/Indicator.vala"
	_tmp0_ = self->priv->display_widget;
#line 208 "../src/Indicator.vala"
	_tmp1_ = self->priv->volume_control;
#line 208 "../src/Indicator.vala"
	_tmp2_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp1_);
#line 208 "../src/Indicator.vala"
	_tmp3_ = _tmp2_;
#line 208 "../src/Indicator.vala"
	_tmp4_ = sound_indicator_get_volume_icon (self, _tmp3_->volume);
#line 208 "../src/Indicator.vala"
	display_widget_set_icon_name (_tmp0_, _tmp4_);
#line 209 "../src/Indicator.vala"
	result = FALSE;
#line 209 "../src/Indicator.vala"
	return result;
#line 549 "Indicator.c"
}

static gboolean
_____lambda56__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda56_ ((SoundIndicator*) self);
#line 205 "../src/Indicator.vala"
	return result;
#line 559 "Indicator.c"
}

static void
sound_indicator_on_is_playing_change (SoundIndicator* self)
{
	SoundServicesVolumeControlPulse* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	SoundServicesVolumeControlPulse* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	DisplayWidget* _tmp6_;
	SoundServicesVolumeControlPulse* _tmp7_;
	SoundServicesVolumeControlVolume* _tmp8_;
	SoundServicesVolumeControlVolume* _tmp9_;
	const gchar* _tmp10_;
#line 192 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 193 "../src/Indicator.vala"
	_tmp0_ = self->priv->volume_control;
#line 193 "../src/Indicator.vala"
	_tmp1_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp0_);
#line 193 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 193 "../src/Indicator.vala"
	if (!_tmp2_) {
#line 194 "../src/Indicator.vala"
		self->priv->mute_blocks_sound = FALSE;
#line 195 "../src/Indicator.vala"
		return;
#line 590 "Indicator.c"
	}
#line 197 "../src/Indicator.vala"
	_tmp3_ = self->priv->volume_control;
#line 197 "../src/Indicator.vala"
	_tmp4_ = sound_services_volume_control_get_is_playing ((SoundServicesVolumeControl*) _tmp3_);
#line 197 "../src/Indicator.vala"
	_tmp5_ = _tmp4_;
#line 197 "../src/Indicator.vala"
	if (_tmp5_) {
#line 198 "../src/Indicator.vala"
		self->priv->mute_blocks_sound = TRUE;
#line 602 "Indicator.c"
	} else {
#line 199 "../src/Indicator.vala"
		if (self->priv->mute_blocks_sound) {
#line 201 "../src/Indicator.vala"
			if (self->priv->sound_was_blocked_timeout_id > ((guint) 0)) {
#line 202 "../src/Indicator.vala"
				g_source_remove (self->priv->sound_was_blocked_timeout_id);
#line 610 "Indicator.c"
			}
#line 205 "../src/Indicator.vala"
			self->priv->sound_was_blocked_timeout_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 5, _____lambda56__gsource_func, g_object_ref (self), g_object_unref);
#line 614 "Indicator.c"
		}
	}
#line 213 "../src/Indicator.vala"
	_tmp6_ = self->priv->display_widget;
#line 213 "../src/Indicator.vala"
	_tmp7_ = self->priv->volume_control;
#line 213 "../src/Indicator.vala"
	_tmp8_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp7_);
#line 213 "../src/Indicator.vala"
	_tmp9_ = _tmp8_;
#line 213 "../src/Indicator.vala"
	_tmp10_ = sound_indicator_get_volume_icon (self, _tmp9_->volume);
#line 213 "../src/Indicator.vala"
	display_widget_set_icon_name (_tmp6_, _tmp10_);
#line 629 "Indicator.c"
}

static void
sound_indicator_on_volume_icon_scroll_event (SoundIndicator* self,
                                             GdkEventScroll* e)
{
	gdouble dir = 0.0;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
#line 216 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 216 "../src/Indicator.vala"
	g_return_if_fail (e != NULL);
#line 217 "../src/Indicator.vala"
	dir = 0.0;
#line 218 "../src/Indicator.vala"
	_tmp1_ = sound_indicator_handle_scroll_event (self, e, &_tmp0_);
#line 218 "../src/Indicator.vala"
	dir = _tmp0_;
#line 218 "../src/Indicator.vala"
	if (_tmp1_) {
#line 219 "../src/Indicator.vala"
		sound_indicator_handle_change (self, dir, FALSE);
#line 653 "Indicator.c"
	}
}

static void
sound_indicator_on_mic_icon_scroll_event (SoundIndicator* self,
                                          GdkEventScroll* e)
{
	gdouble dir = 0.0;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
#line 223 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 223 "../src/Indicator.vala"
	g_return_if_fail (e != NULL);
#line 224 "../src/Indicator.vala"
	dir = 0.0;
#line 225 "../src/Indicator.vala"
	_tmp1_ = sound_indicator_handle_scroll_event (self, e, &_tmp0_);
#line 225 "../src/Indicator.vala"
	dir = _tmp0_;
#line 225 "../src/Indicator.vala"
	if (_tmp1_) {
#line 226 "../src/Indicator.vala"
		sound_indicator_handle_change (self, dir, TRUE);
#line 678 "Indicator.c"
	}
}

static void
sound_indicator_update_mic_visibility (SoundIndicator* self)
{
	SoundServicesVolumeControlPulse* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 230 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 231 "../src/Indicator.vala"
	_tmp0_ = self->priv->volume_control;
#line 231 "../src/Indicator.vala"
	_tmp1_ = sound_services_volume_control_get_is_listening ((SoundServicesVolumeControl*) _tmp0_);
#line 231 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 231 "../src/Indicator.vala"
	if (_tmp2_) {
#line 698 "Indicator.c"
		SoundWidgetsScale* _tmp3_;
		SoundWidgetsScale* _tmp4_;
		GtkSeparator* _tmp5_;
		GtkSeparator* _tmp6_;
		SoundWidgetsDeviceManagerWidget* _tmp7_;
		SoundWidgetsDeviceManagerWidget* _tmp8_;
		DisplayWidget* _tmp9_;
#line 232 "../src/Indicator.vala"
		_tmp3_ = self->priv->mic_scale;
#line 232 "../src/Indicator.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp3_, FALSE);
#line 233 "../src/Indicator.vala"
		_tmp4_ = self->priv->mic_scale;
#line 233 "../src/Indicator.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp4_);
#line 234 "../src/Indicator.vala"
		_tmp5_ = self->priv->mic_separator;
#line 234 "../src/Indicator.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp5_, FALSE);
#line 235 "../src/Indicator.vala"
		_tmp6_ = self->priv->mic_separator;
#line 235 "../src/Indicator.vala"
		gtk_widget_show ((GtkWidget*) _tmp6_);
#line 236 "../src/Indicator.vala"
		_tmp7_ = self->priv->input_device_manager;
#line 236 "../src/Indicator.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp7_, FALSE);
#line 237 "../src/Indicator.vala"
		_tmp8_ = self->priv->input_device_manager;
#line 237 "../src/Indicator.vala"
		gtk_widget_show ((GtkWidget*) _tmp8_);
#line 238 "../src/Indicator.vala"
		_tmp9_ = self->priv->display_widget;
#line 238 "../src/Indicator.vala"
		display_widget_set_show_mic (_tmp9_, TRUE);
#line 734 "Indicator.c"
	} else {
		SoundWidgetsScale* _tmp10_;
		SoundWidgetsScale* _tmp11_;
		GtkSeparator* _tmp12_;
		GtkSeparator* _tmp13_;
		SoundWidgetsDeviceManagerWidget* _tmp14_;
		SoundWidgetsDeviceManagerWidget* _tmp15_;
		DisplayWidget* _tmp16_;
#line 240 "../src/Indicator.vala"
		_tmp10_ = self->priv->mic_scale;
#line 240 "../src/Indicator.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp10_, TRUE);
#line 241 "../src/Indicator.vala"
		_tmp11_ = self->priv->mic_scale;
#line 241 "../src/Indicator.vala"
		gtk_widget_hide ((GtkWidget*) _tmp11_);
#line 242 "../src/Indicator.vala"
		_tmp12_ = self->priv->mic_separator;
#line 242 "../src/Indicator.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp12_, TRUE);
#line 243 "../src/Indicator.vala"
		_tmp13_ = self->priv->mic_separator;
#line 243 "../src/Indicator.vala"
		gtk_widget_hide ((GtkWidget*) _tmp13_);
#line 244 "../src/Indicator.vala"
		_tmp14_ = self->priv->input_device_manager;
#line 244 "../src/Indicator.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp14_, TRUE);
#line 245 "../src/Indicator.vala"
		_tmp15_ = self->priv->input_device_manager;
#line 245 "../src/Indicator.vala"
		gtk_widget_hide ((GtkWidget*) _tmp15_);
#line 246 "../src/Indicator.vala"
		_tmp16_ = self->priv->display_widget;
#line 246 "../src/Indicator.vala"
		display_widget_set_show_mic (_tmp16_, FALSE);
#line 771 "Indicator.c"
	}
}

static const gchar*
sound_indicator_get_volume_icon (SoundIndicator* self,
                                 gdouble volume)
{
	gboolean _tmp0_ = FALSE;
	const gchar* result;
#line 250 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 251 "../src/Indicator.vala"
	if (volume <= ((gdouble) 0)) {
#line 251 "../src/Indicator.vala"
		_tmp0_ = TRUE;
#line 787 "Indicator.c"
	} else {
		SoundServicesVolumeControlPulse* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 251 "../src/Indicator.vala"
		_tmp1_ = self->priv->volume_control;
#line 251 "../src/Indicator.vala"
		_tmp2_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp1_);
#line 251 "../src/Indicator.vala"
		_tmp3_ = _tmp2_;
#line 251 "../src/Indicator.vala"
		_tmp0_ = _tmp3_;
#line 800 "Indicator.c"
	}
#line 251 "../src/Indicator.vala"
	if (_tmp0_) {
#line 804 "Indicator.c"
		const gchar* _tmp4_ = NULL;
#line 252 "../src/Indicator.vala"
		if (self->priv->mute_blocks_sound) {
#line 252 "../src/Indicator.vala"
			_tmp4_ = "audio-volume-muted-blocking-symbolic";
#line 810 "Indicator.c"
		} else {
#line 252 "../src/Indicator.vala"
			_tmp4_ = "audio-volume-muted-symbolic";
#line 814 "Indicator.c"
		}
#line 252 "../src/Indicator.vala"
		result = _tmp4_;
#line 252 "../src/Indicator.vala"
		return result;
#line 820 "Indicator.c"
	} else {
#line 253 "../src/Indicator.vala"
		if (volume <= 0.3) {
#line 254 "../src/Indicator.vala"
			result = "audio-volume-low-symbolic";
#line 254 "../src/Indicator.vala"
			return result;
#line 828 "Indicator.c"
		} else {
#line 255 "../src/Indicator.vala"
			if (volume <= 0.7) {
#line 256 "../src/Indicator.vala"
				result = "audio-volume-medium-symbolic";
#line 256 "../src/Indicator.vala"
				return result;
#line 836 "Indicator.c"
			} else {
#line 258 "../src/Indicator.vala"
				result = "audio-volume-high-symbolic";
#line 258 "../src/Indicator.vala"
				return result;
#line 842 "Indicator.c"
			}
		}
	}
}

static void
sound_indicator_on_volume_switch_change (SoundIndicator* self)
{
	SoundWidgetsScale* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 262 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/Indicator.vala"
	_tmp0_ = self->priv->volume_scale;
#line 263 "../src/Indicator.vala"
	_tmp1_ = sound_widgets_scale_get_active (_tmp0_);
#line 263 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 263 "../src/Indicator.vala"
	if (_tmp2_) {
#line 864 "Indicator.c"
		SoundServicesVolumeControlPulse* _tmp3_;
#line 264 "../src/Indicator.vala"
		_tmp3_ = self->priv->volume_control;
#line 264 "../src/Indicator.vala"
		sound_services_volume_control_set_mute ((SoundServicesVolumeControl*) _tmp3_, FALSE);
#line 870 "Indicator.c"
	} else {
		SoundServicesVolumeControlPulse* _tmp4_;
#line 266 "../src/Indicator.vala"
		_tmp4_ = self->priv->volume_control;
#line 266 "../src/Indicator.vala"
		sound_services_volume_control_set_mute ((SoundServicesVolumeControl*) _tmp4_, TRUE);
#line 877 "Indicator.c"
	}
}

static void
sound_indicator_on_mic_switch_change (SoundIndicator* self)
{
	SoundWidgetsScale* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 270 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 271 "../src/Indicator.vala"
	_tmp0_ = self->priv->mic_scale;
#line 271 "../src/Indicator.vala"
	_tmp1_ = sound_widgets_scale_get_active (_tmp0_);
#line 271 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 271 "../src/Indicator.vala"
	if (_tmp2_) {
#line 897 "Indicator.c"
		SoundServicesVolumeControlPulse* _tmp3_;
#line 272 "../src/Indicator.vala"
		_tmp3_ = self->priv->volume_control;
#line 272 "../src/Indicator.vala"
		sound_services_volume_control_pulse_set_mic_mute (_tmp3_, FALSE);
#line 903 "Indicator.c"
	} else {
		SoundServicesVolumeControlPulse* _tmp4_;
#line 274 "../src/Indicator.vala"
		_tmp4_ = self->priv->volume_control;
#line 274 "../src/Indicator.vala"
		sound_services_volume_control_pulse_set_mic_mute (_tmp4_, TRUE);
#line 910 "Indicator.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 279 "../src/Indicator.vala"
	return self ? g_object_ref (self) : NULL;
#line 919 "Indicator.c"
}

static GtkWidget*
sound_indicator_real_get_display_widget (WingpanelIndicator* base)
{
	SoundIndicator * self;
	DisplayWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* result;
#line 278 "../src/Indicator.vala"
	self = (SoundIndicator*) base;
#line 279 "../src/Indicator.vala"
	_tmp0_ = self->priv->display_widget;
#line 279 "../src/Indicator.vala"
	_tmp1_ = _g_object_ref0 ((GtkWidget*) _tmp0_);
#line 279 "../src/Indicator.vala"
	result = _tmp1_;
#line 279 "../src/Indicator.vala"
	return result;
#line 939 "Indicator.c"
}

static void
_sound_indicator_on_mic_switch_change_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
#line 316 "../src/Indicator.vala"
	sound_indicator_on_mic_switch_change ((SoundIndicator*) self);
#line 949 "Indicator.c"
}

static void
___lambda58_ (SoundIndicator* self)
{
	SoundServicesVolumeControlPulse* _tmp0_;
	SoundWidgetsScale* _tmp1_;
	GtkScale* _tmp2_;
	GtkScale* _tmp3_;
#line 319 "../src/Indicator.vala"
	_tmp0_ = self->priv->volume_control;
#line 319 "../src/Indicator.vala"
	_tmp1_ = self->priv->mic_scale;
#line 319 "../src/Indicator.vala"
	_tmp2_ = sound_widgets_scale_get_scale_widget (_tmp1_);
#line 319 "../src/Indicator.vala"
	_tmp3_ = _tmp2_;
#line 319 "../src/Indicator.vala"
	sound_services_volume_control_set_mic_volume ((SoundServicesVolumeControl*) _tmp0_, gtk_range_get_value ((GtkRange*) _tmp3_));
#line 969 "Indicator.c"
}

static void
____lambda58__gtk_range_value_changed (GtkRange* _sender,
                                       gpointer self)
{
#line 318 "../src/Indicator.vala"
	___lambda58_ ((SoundIndicator*) self);
#line 978 "Indicator.c"
}

static gboolean
___lambda59_ (SoundIndicator* self)
{
	gboolean result;
#line 323 "../src/Indicator.vala"
	sound_indicator_notify_change (self, TRUE);
#line 324 "../src/Indicator.vala"
	result = FALSE;
#line 324 "../src/Indicator.vala"
	return result;
#line 991 "Indicator.c"
}

static gboolean
____lambda59__gtk_widget_button_release_event (GtkWidget* _sender,
                                               GdkEventButton* event,
                                               gpointer self)
{
	gboolean result;
	result = ___lambda59_ ((SoundIndicator*) self);
#line 322 "../src/Indicator.vala"
	return result;
#line 1003 "Indicator.c"
}

static gboolean
___lambda60_ (SoundIndicator* self,
              GdkEventScroll* e)
{
	gdouble dir = 0.0;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
	gboolean result;
#line 327 "../src/Indicator.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 328 "../src/Indicator.vala"
	dir = 0.0;
#line 329 "../src/Indicator.vala"
	_tmp1_ = sound_indicator_handle_scroll_event (self, e, &_tmp0_);
#line 329 "../src/Indicator.vala"
	dir = _tmp0_;
#line 329 "../src/Indicator.vala"
	if (_tmp1_) {
#line 330 "../src/Indicator.vala"
		sound_indicator_handle_change (self, dir, TRUE);
#line 1026 "Indicator.c"
	}
#line 333 "../src/Indicator.vala"
	result = TRUE;
#line 333 "../src/Indicator.vala"
	return result;
#line 1032 "Indicator.c"
}

static gboolean
____lambda60__gtk_widget_scroll_event (GtkWidget* _sender,
                                       GdkEventScroll* event,
                                       gpointer self)
{
	gboolean result;
	result = ___lambda60_ ((SoundIndicator*) self, event);
#line 327 "../src/Indicator.vala"
	return result;
#line 1044 "Indicator.c"
}

static void
___lambda61_ (SoundIndicator* self)
{
#line 337 "../src/Indicator.vala"
	g_signal_emit_by_name ((WingpanelIndicator*) self, "close");
#line 1052 "Indicator.c"
}

static void
____lambda61__sound_widgets_player_list_close (SoundWidgetsPlayerList* _sender,
                                               gpointer self)
{
#line 336 "../src/Indicator.vala"
	___lambda61_ ((SoundIndicator*) self);
#line 1061 "Indicator.c"
}

static void
___lambda62_ (SoundIndicator* self)
{
#line 341 "../src/Indicator.vala"
	sound_indicator_show_settings (self);
#line 1069 "Indicator.c"
}

static void
____lambda62__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
#line 340 "../src/Indicator.vala"
	___lambda62_ ((SoundIndicator*) self);
#line 1078 "Indicator.c"
}

static void
___lambda63_ (SoundIndicator* self)
{
	SoundServicesVolumeControlPulse* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 345 "../src/Indicator.vala"
	_tmp0_ = self->priv->volume_control;
#line 345 "../src/Indicator.vala"
	_tmp1_ = sound_services_volume_control_get_headphone_plugged ((SoundServicesVolumeControl*) _tmp0_);
#line 345 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 345 "../src/Indicator.vala"
	if (!_tmp2_) {
#line 1095 "Indicator.c"
		SoundWidgetsPlayerList* _tmp3_;
#line 346 "../src/Indicator.vala"
		_tmp3_ = self->priv->mpris;
#line 346 "../src/Indicator.vala"
		sound_widgets_player_list_pause_all (_tmp3_);
#line 1101 "Indicator.c"
	}
}

static void
____lambda63__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 344 "../src/Indicator.vala"
	___lambda63_ ((SoundIndicator*) self);
#line 1112 "Indicator.c"
}

static gboolean
___lambda64_ (SoundIndicator* self,
              GdkEventButton* e)
{
	gboolean result;
#line 350 "../src/Indicator.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 351 "../src/Indicator.vala"
	sound_indicator_notify_change (self, FALSE);
#line 352 "../src/Indicator.vala"
	result = FALSE;
#line 352 "../src/Indicator.vala"
	return result;
#line 1128 "Indicator.c"
}

static gboolean
____lambda64__gtk_widget_button_release_event (GtkWidget* _sender,
                                               GdkEventButton* event,
                                               gpointer self)
{
	gboolean result;
	result = ___lambda64_ ((SoundIndicator*) self, event);
#line 350 "../src/Indicator.vala"
	return result;
#line 1140 "Indicator.c"
}

static gboolean
___lambda65_ (SoundIndicator* self,
              GdkEventScroll* e)
{
	gdouble dir = 0.0;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
	gboolean result;
#line 355 "../src/Indicator.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 356 "../src/Indicator.vala"
	dir = 0.0;
#line 357 "../src/Indicator.vala"
	_tmp1_ = sound_indicator_handle_scroll_event (self, e, &_tmp0_);
#line 357 "../src/Indicator.vala"
	dir = _tmp0_;
#line 357 "../src/Indicator.vala"
	if (_tmp1_) {
#line 358 "../src/Indicator.vala"
		sound_indicator_handle_change (self, dir, FALSE);
#line 1163 "Indicator.c"
	}
#line 361 "../src/Indicator.vala"
	result = TRUE;
#line 361 "../src/Indicator.vala"
	return result;
#line 1169 "Indicator.c"
}

static gboolean
____lambda65__gtk_widget_scroll_event (GtkWidget* _sender,
                                       GdkEventScroll* event,
                                       gpointer self)
{
	gboolean result;
	result = ___lambda65_ ((SoundIndicator*) self, event);
#line 355 "../src/Indicator.vala"
	return result;
#line 1181 "Indicator.c"
}

static void
_sound_indicator_on_volume_switch_change_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self)
{
#line 364 "../src/Indicator.vala"
	sound_indicator_on_volume_switch_change ((SoundIndicator*) self);
#line 1191 "Indicator.c"
}

static void
___lambda66_ (SoundIndicator* self)
{
	gdouble val = 0.0;
	SoundWidgetsScale* _tmp0_;
	GtkScale* _tmp1_;
	GtkScale* _tmp2_;
	SoundServicesVolumeControlVolume* vol = NULL;
	SoundServicesVolumeControlVolume* _tmp3_ = NULL;
	SoundServicesVolumeControlPulse* _tmp4_;
	SoundWidgetsScale* _tmp5_;
	SoundWidgetsScale* _tmp6_;
	GtkScale* _tmp7_;
	GtkScale* _tmp8_;
	const gchar* _tmp9_;
#line 367 "../src/Indicator.vala"
	_tmp0_ = self->priv->volume_scale;
#line 367 "../src/Indicator.vala"
	_tmp1_ = sound_widgets_scale_get_scale_widget (_tmp0_);
#line 367 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 367 "../src/Indicator.vala"
	val = gtk_range_get_value ((GtkRange*) _tmp2_) * self->priv->max_volume;
#line 368 "../src/Indicator.vala"
	_tmp3_ = sound_services_volume_control_volume_new ();
#line 368 "../src/Indicator.vala"
	_tmp3_->volume = CLAMP (val, 0.0, self->priv->max_volume);
#line 368 "../src/Indicator.vala"
	_tmp3_->reason = SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_USER_KEYPRESS;
#line 368 "../src/Indicator.vala"
	vol = _tmp3_;
#line 372 "../src/Indicator.vala"
	_tmp4_ = self->priv->volume_control;
#line 372 "../src/Indicator.vala"
	sound_services_volume_control_set_volume ((SoundServicesVolumeControl*) _tmp4_, vol);
#line 373 "../src/Indicator.vala"
	_tmp5_ = self->priv->volume_scale;
#line 373 "../src/Indicator.vala"
	_tmp6_ = self->priv->volume_scale;
#line 373 "../src/Indicator.vala"
	_tmp7_ = sound_widgets_scale_get_scale_widget (_tmp6_);
#line 373 "../src/Indicator.vala"
	_tmp8_ = _tmp7_;
#line 373 "../src/Indicator.vala"
	_tmp9_ = sound_indicator_get_volume_icon (self, gtk_range_get_value ((GtkRange*) _tmp8_));
#line 373 "../src/Indicator.vala"
	sound_widgets_scale_set_icon (_tmp5_, _tmp9_);
#line 366 "../src/Indicator.vala"
	_g_object_unref0 (vol);
#line 1243 "Indicator.c"
}

static void
____lambda66__gtk_range_value_changed (GtkRange* _sender,
                                       gpointer self)
{
#line 366 "../src/Indicator.vala"
	___lambda66_ ((SoundIndicator*) self);
#line 1252 "Indicator.c"
}

static GtkWidget*
sound_indicator_real_get_widget (WingpanelIndicator* base)
{
	SoundIndicator * self;
	GtkBox* _tmp0_;
	GtkBox* _tmp70_;
	GtkWidget* _tmp71_;
	GtkWidget* result;
#line 283 "../src/Indicator.vala"
	self = (SoundIndicator*) base;
#line 284 "../src/Indicator.vala"
	_tmp0_ = self->priv->main_box;
#line 284 "../src/Indicator.vala"
	if (_tmp0_ == NULL) {
#line 1269 "Indicator.c"
		SoundWidgetsPlayerList* _tmp1_;
		SoundWidgetsScale* _tmp2_;
		GtkSwitch* _tmp3_;
		GtkSwitch* _tmp4_;
		SoundServicesVolumeControlPulse* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		SoundWidgetsScale* _tmp8_;
		SoundServicesVolumeControlPulse* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
		SoundWidgetsScale* _tmp12_;
		GtkScale* _tmp13_;
		GtkScale* _tmp14_;
		SoundServicesVolumeControlPulse* _tmp15_;
		SoundServicesVolumeControlVolume* _tmp16_;
		SoundServicesVolumeControlVolume* _tmp17_;
		SoundWidgetsScale* _tmp18_;
		SoundWidgetsScale* _tmp19_;
		GtkScale* _tmp20_;
		GtkScale* _tmp21_;
		const gchar* _tmp22_;
		SoundWidgetsScale* _tmp23_;
		SoundServicesVolumeControlPulse* _tmp24_;
		gboolean _tmp25_;
		gboolean _tmp26_;
		GtkSeparator* _tmp27_;
		GtkModelButton* settings_button = NULL;
		gchar* _tmp28_;
		GtkModelButton* _tmp29_ = NULL;
		GtkBox* _tmp30_;
		GtkBox* _tmp31_;
		SoundWidgetsPlayerList* _tmp32_;
		GtkBox* _tmp33_;
		GtkSeparator* _tmp34_;
		GtkSeparator* _tmp35_;
		GtkBox* _tmp36_;
		SoundWidgetsScale* _tmp37_;
		GtkBox* _tmp38_;
		SoundWidgetsDeviceManagerWidget* _tmp39_;
		GtkBox* _tmp40_;
		GtkSeparator* _tmp41_;
		GtkSeparator* _tmp42_;
		GtkBox* _tmp43_;
		SoundWidgetsScale* _tmp44_;
		GtkBox* _tmp45_;
		SoundWidgetsDeviceManagerWidget* _tmp46_;
		GtkBox* _tmp47_;
		GtkSeparator* _tmp48_;
		GtkBox* _tmp49_;
		GtkModelButton* _tmp50_;
		SoundWidgetsScale* _tmp51_;
		SoundWidgetsScale* _tmp52_;
		GtkScale* _tmp53_;
		GtkScale* _tmp54_;
		SoundWidgetsScale* _tmp55_;
		GtkScale* _tmp56_;
		GtkScale* _tmp57_;
		SoundWidgetsScale* _tmp58_;
		SoundWidgetsPlayerList* _tmp59_;
		GtkModelButton* _tmp60_;
		SoundServicesVolumeControlPulse* _tmp61_;
		SoundWidgetsScale* _tmp62_;
		GtkScale* _tmp63_;
		GtkScale* _tmp64_;
		SoundWidgetsScale* _tmp65_;
		SoundWidgetsScale* _tmp66_;
		SoundWidgetsScale* _tmp67_;
		GtkScale* _tmp68_;
		GtkScale* _tmp69_;
#line 285 "../src/Indicator.vala"
		_tmp1_ = sound_widgets_player_list_new ();
#line 285 "../src/Indicator.vala"
		g_object_ref_sink (_tmp1_);
#line 285 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->mpris);
#line 285 "../src/Indicator.vala"
		self->priv->mpris = _tmp1_;
#line 287 "../src/Indicator.vala"
		_tmp2_ = self->priv->volume_scale;
#line 287 "../src/Indicator.vala"
		_tmp3_ = sound_widgets_scale_get_switch_widget (_tmp2_);
#line 287 "../src/Indicator.vala"
		_tmp4_ = _tmp3_;
#line 287 "../src/Indicator.vala"
		_tmp5_ = self->priv->volume_control;
#line 287 "../src/Indicator.vala"
		_tmp6_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp5_);
#line 287 "../src/Indicator.vala"
		_tmp7_ = _tmp6_;
#line 287 "../src/Indicator.vala"
		gtk_switch_set_active (_tmp4_, !_tmp7_);
#line 288 "../src/Indicator.vala"
		_tmp8_ = self->priv->volume_scale;
#line 288 "../src/Indicator.vala"
		_tmp9_ = self->priv->volume_control;
#line 288 "../src/Indicator.vala"
		_tmp10_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp9_);
#line 288 "../src/Indicator.vala"
		_tmp11_ = _tmp10_;
#line 288 "../src/Indicator.vala"
		sound_widgets_scale_set_active (_tmp8_, !_tmp11_);
#line 289 "../src/Indicator.vala"
		_tmp12_ = self->priv->volume_scale;
#line 289 "../src/Indicator.vala"
		_tmp13_ = sound_widgets_scale_get_scale_widget (_tmp12_);
#line 289 "../src/Indicator.vala"
		_tmp14_ = _tmp13_;
#line 289 "../src/Indicator.vala"
		_tmp15_ = self->priv->volume_control;
#line 289 "../src/Indicator.vala"
		_tmp16_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp15_);
#line 289 "../src/Indicator.vala"
		_tmp17_ = _tmp16_;
#line 289 "../src/Indicator.vala"
		gtk_range_set_value ((GtkRange*) _tmp14_, _tmp17_->volume);
#line 290 "../src/Indicator.vala"
		_tmp18_ = self->priv->volume_scale;
#line 290 "../src/Indicator.vala"
		_tmp19_ = self->priv->volume_scale;
#line 290 "../src/Indicator.vala"
		_tmp20_ = sound_widgets_scale_get_scale_widget (_tmp19_);
#line 290 "../src/Indicator.vala"
		_tmp21_ = _tmp20_;
#line 290 "../src/Indicator.vala"
		_tmp22_ = sound_indicator_get_volume_icon (self, gtk_range_get_value ((GtkRange*) _tmp21_));
#line 290 "../src/Indicator.vala"
		sound_widgets_scale_set_icon (_tmp18_, _tmp22_);
#line 292 "../src/Indicator.vala"
		sound_indicator_set_max_volume (self);
#line 294 "../src/Indicator.vala"
		_tmp23_ = self->priv->mic_scale;
#line 294 "../src/Indicator.vala"
		_tmp24_ = self->priv->volume_control;
#line 294 "../src/Indicator.vala"
		_tmp25_ = sound_services_volume_control_pulse_get_micMute (_tmp24_);
#line 294 "../src/Indicator.vala"
		_tmp26_ = _tmp25_;
#line 294 "../src/Indicator.vala"
		sound_widgets_scale_set_active (_tmp23_, !_tmp26_);
#line 296 "../src/Indicator.vala"
		_tmp27_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 296 "../src/Indicator.vala"
		g_object_ref_sink (_tmp27_);
#line 296 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->mic_separator);
#line 296 "../src/Indicator.vala"
		self->priv->mic_separator = _tmp27_;
#line 298 "../src/Indicator.vala"
		sound_indicator_update_mic_visibility (self);
#line 300 "../src/Indicator.vala"
		_tmp28_ = g_strdup (_ ("Sound Settings…"));
#line 300 "../src/Indicator.vala"
		_tmp29_ = (GtkModelButton*) gtk_model_button_new ();
#line 300 "../src/Indicator.vala"
		g_object_set (_tmp29_, "text", _tmp28_, NULL);
#line 300 "../src/Indicator.vala"
		_g_free0 (_tmp28_);
#line 300 "../src/Indicator.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp29_, 3);
#line 300 "../src/Indicator.vala"
		g_object_ref_sink (_tmp29_);
#line 300 "../src/Indicator.vala"
		settings_button = _tmp29_;
#line 305 "../src/Indicator.vala"
		_tmp30_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 305 "../src/Indicator.vala"
		g_object_ref_sink (_tmp30_);
#line 305 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->main_box);
#line 305 "../src/Indicator.vala"
		self->priv->main_box = _tmp30_;
#line 306 "../src/Indicator.vala"
		_tmp31_ = self->priv->main_box;
#line 306 "../src/Indicator.vala"
		_tmp32_ = self->priv->mpris;
#line 306 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp31_, (GtkWidget*) _tmp32_);
#line 307 "../src/Indicator.vala"
		_tmp33_ = self->priv->main_box;
#line 307 "../src/Indicator.vala"
		_tmp34_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 307 "../src/Indicator.vala"
		g_object_ref_sink (_tmp34_);
#line 307 "../src/Indicator.vala"
		_tmp35_ = _tmp34_;
#line 307 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp33_, (GtkWidget*) _tmp35_);
#line 307 "../src/Indicator.vala"
		_g_object_unref0 (_tmp35_);
#line 308 "../src/Indicator.vala"
		_tmp36_ = self->priv->main_box;
#line 308 "../src/Indicator.vala"
		_tmp37_ = self->priv->volume_scale;
#line 308 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
#line 309 "../src/Indicator.vala"
		_tmp38_ = self->priv->main_box;
#line 309 "../src/Indicator.vala"
		_tmp39_ = self->priv->output_device_manager;
#line 309 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp38_, (GtkWidget*) _tmp39_);
#line 310 "../src/Indicator.vala"
		_tmp40_ = self->priv->main_box;
#line 310 "../src/Indicator.vala"
		_tmp41_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 310 "../src/Indicator.vala"
		g_object_ref_sink (_tmp41_);
#line 310 "../src/Indicator.vala"
		_tmp42_ = _tmp41_;
#line 310 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp40_, (GtkWidget*) _tmp42_);
#line 310 "../src/Indicator.vala"
		_g_object_unref0 (_tmp42_);
#line 311 "../src/Indicator.vala"
		_tmp43_ = self->priv->main_box;
#line 311 "../src/Indicator.vala"
		_tmp44_ = self->priv->mic_scale;
#line 311 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp43_, (GtkWidget*) _tmp44_);
#line 312 "../src/Indicator.vala"
		_tmp45_ = self->priv->main_box;
#line 312 "../src/Indicator.vala"
		_tmp46_ = self->priv->input_device_manager;
#line 312 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp45_, (GtkWidget*) _tmp46_);
#line 313 "../src/Indicator.vala"
		_tmp47_ = self->priv->main_box;
#line 313 "../src/Indicator.vala"
		_tmp48_ = self->priv->mic_separator;
#line 313 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp47_, (GtkWidget*) _tmp48_);
#line 314 "../src/Indicator.vala"
		_tmp49_ = self->priv->main_box;
#line 314 "../src/Indicator.vala"
		_tmp50_ = settings_button;
#line 314 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp49_, (GtkWidget*) _tmp50_);
#line 316 "../src/Indicator.vala"
		_tmp51_ = self->priv->mic_scale;
#line 316 "../src/Indicator.vala"
		g_signal_connect_object ((GObject*) _tmp51_, "notify::active", (GCallback) _sound_indicator_on_mic_switch_change_g_object_notify, self, 0);
#line 318 "../src/Indicator.vala"
		_tmp52_ = self->priv->mic_scale;
#line 318 "../src/Indicator.vala"
		_tmp53_ = sound_widgets_scale_get_scale_widget (_tmp52_);
#line 318 "../src/Indicator.vala"
		_tmp54_ = _tmp53_;
#line 318 "../src/Indicator.vala"
		g_signal_connect_object ((GtkRange*) _tmp54_, "value-changed", (GCallback) ____lambda58__gtk_range_value_changed, self, 0);
#line 322 "../src/Indicator.vala"
		_tmp55_ = self->priv->mic_scale;
#line 322 "../src/Indicator.vala"
		_tmp56_ = sound_widgets_scale_get_scale_widget (_tmp55_);
#line 322 "../src/Indicator.vala"
		_tmp57_ = _tmp56_;
#line 322 "../src/Indicator.vala"
		g_signal_connect_object ((GtkWidget*) _tmp57_, "button-release-event", (GCallback) ____lambda59__gtk_widget_button_release_event, self, 0);
#line 327 "../src/Indicator.vala"
		_tmp58_ = self->priv->mic_scale;
#line 327 "../src/Indicator.vala"
		g_signal_connect_object ((GtkWidget*) _tmp58_, "scroll-event", (GCallback) ____lambda60__gtk_widget_scroll_event, self, G_CONNECT_AFTER);
#line 336 "../src/Indicator.vala"
		_tmp59_ = self->priv->mpris;
#line 336 "../src/Indicator.vala"
		g_signal_connect_object (_tmp59_, "close", (GCallback) ____lambda61__sound_widgets_player_list_close, self, 0);
#line 340 "../src/Indicator.vala"
		_tmp60_ = settings_button;
#line 340 "../src/Indicator.vala"
		g_signal_connect_object ((GtkButton*) _tmp60_, "clicked", (GCallback) ____lambda62__gtk_button_clicked, self, 0);
#line 344 "../src/Indicator.vala"
		_tmp61_ = self->priv->volume_control;
#line 344 "../src/Indicator.vala"
		g_signal_connect_object ((GObject*) _tmp61_, "notify::headphone-plugged", (GCallback) ____lambda63__g_object_notify, self, 0);
#line 350 "../src/Indicator.vala"
		_tmp62_ = self->priv->volume_scale;
#line 350 "../src/Indicator.vala"
		_tmp63_ = sound_widgets_scale_get_scale_widget (_tmp62_);
#line 350 "../src/Indicator.vala"
		_tmp64_ = _tmp63_;
#line 350 "../src/Indicator.vala"
		g_signal_connect_object ((GtkWidget*) _tmp64_, "button-release-event", (GCallback) ____lambda64__gtk_widget_button_release_event, self, 0);
#line 355 "../src/Indicator.vala"
		_tmp65_ = self->priv->volume_scale;
#line 355 "../src/Indicator.vala"
		g_signal_connect_object ((GtkWidget*) _tmp65_, "scroll-event", (GCallback) ____lambda65__gtk_widget_scroll_event, self, G_CONNECT_AFTER);
#line 364 "../src/Indicator.vala"
		_tmp66_ = self->priv->volume_scale;
#line 364 "../src/Indicator.vala"
		g_signal_connect_object ((GObject*) _tmp66_, "notify::active", (GCallback) _sound_indicator_on_volume_switch_change_g_object_notify, self, 0);
#line 366 "../src/Indicator.vala"
		_tmp67_ = self->priv->volume_scale;
#line 366 "../src/Indicator.vala"
		_tmp68_ = sound_widgets_scale_get_scale_widget (_tmp67_);
#line 366 "../src/Indicator.vala"
		_tmp69_ = _tmp68_;
#line 366 "../src/Indicator.vala"
		g_signal_connect_object ((GtkRange*) _tmp69_, "value-changed", (GCallback) ____lambda66__gtk_range_value_changed, self, 0);
#line 284 "../src/Indicator.vala"
		_g_object_unref0 (settings_button);
#line 1570 "Indicator.c"
	}
#line 377 "../src/Indicator.vala"
	_tmp70_ = self->priv->main_box;
#line 377 "../src/Indicator.vala"
	_tmp71_ = _g_object_ref0 ((GtkWidget*) _tmp70_);
#line 377 "../src/Indicator.vala"
	result = _tmp71_;
#line 377 "../src/Indicator.vala"
	return result;
#line 1580 "Indicator.c"
}

static gboolean
sound_indicator_handle_scroll_event (SoundIndicator* self,
                                     GdkEventScroll* e,
                                     gdouble* dir)
{
	gdouble _vala_dir = 0.0;
	gboolean natural_scroll = FALSE;
	GdkInputSource event_source = 0;
	GdkDevice* _tmp0_;
	GdkInputSource _tmp1_;
	GdkInputSource _tmp2_;
	gboolean result;
#line 388 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 388 "../src/Indicator.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 389 "../src/Indicator.vala"
	_vala_dir = 0.0;
#line 391 "../src/Indicator.vala"
	_tmp0_ = gdk_event_get_source_device ((GdkEvent*) e);
#line 391 "../src/Indicator.vala"
	g_object_get (_tmp0_, "input-source", &_tmp1_, NULL);
#line 391 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 391 "../src/Indicator.vala"
	event_source = _tmp2_;
#line 392 "../src/Indicator.vala"
	if (event_source == GDK_SOURCE_MOUSE) {
#line 1611 "Indicator.c"
		gboolean _tmp3_;
#line 393 "../src/Indicator.vala"
		_tmp3_ = self->priv->_natural_scroll_mouse;
#line 393 "../src/Indicator.vala"
		natural_scroll = _tmp3_;
#line 1617 "Indicator.c"
	} else {
#line 394 "../src/Indicator.vala"
		if (event_source == GDK_SOURCE_TOUCHPAD) {
#line 1621 "Indicator.c"
			gboolean _tmp4_;
#line 395 "../src/Indicator.vala"
			_tmp4_ = self->priv->_natural_scroll_touchpad;
#line 395 "../src/Indicator.vala"
			natural_scroll = _tmp4_;
#line 1627 "Indicator.c"
		} else {
#line 397 "../src/Indicator.vala"
			natural_scroll = FALSE;
#line 1631 "Indicator.c"
		}
	}
#line 400 "../src/Indicator.vala"
	switch (e->direction) {
#line 400 "../src/Indicator.vala"
		case GDK_SCROLL_SMOOTH:
#line 1638 "Indicator.c"
		{
			gdouble abs_x = 0.0;
			gdouble abs_y = 0.0;
#line 402 "../src/Indicator.vala"
			abs_x = MAX (fabs (e->delta_x), 0.0001);
#line 403 "../src/Indicator.vala"
			abs_y = MAX (fabs (e->delta_y), 0.0001);
#line 405 "../src/Indicator.vala"
			if ((abs_y / abs_x) > 2.0) {
#line 406 "../src/Indicator.vala"
				self->priv->total_y_delta = self->priv->total_y_delta + e->delta_y;
#line 1650 "Indicator.c"
			} else {
#line 407 "../src/Indicator.vala"
				if ((abs_x / abs_y) > 2.0) {
#line 408 "../src/Indicator.vala"
					self->priv->total_x_delta = self->priv->total_x_delta + e->delta_x;
#line 1656 "Indicator.c"
				}
			}
#line 411 "../src/Indicator.vala"
			break;
#line 1661 "Indicator.c"
		}
#line 400 "../src/Indicator.vala"
		case GDK_SCROLL_UP:
#line 1665 "Indicator.c"
		{
#line 414 "../src/Indicator.vala"
			self->priv->total_y_delta = -1.0;
#line 415 "../src/Indicator.vala"
			break;
#line 1671 "Indicator.c"
		}
#line 400 "../src/Indicator.vala"
		case GDK_SCROLL_DOWN:
#line 1675 "Indicator.c"
		{
#line 417 "../src/Indicator.vala"
			self->priv->total_y_delta = 1.0;
#line 418 "../src/Indicator.vala"
			break;
#line 1681 "Indicator.c"
		}
#line 400 "../src/Indicator.vala"
		case GDK_SCROLL_LEFT:
#line 1685 "Indicator.c"
		{
#line 420 "../src/Indicator.vala"
			self->priv->total_x_delta = -1.0;
#line 421 "../src/Indicator.vala"
			break;
#line 1691 "Indicator.c"
		}
#line 400 "../src/Indicator.vala"
		case GDK_SCROLL_RIGHT:
#line 1695 "Indicator.c"
		{
#line 423 "../src/Indicator.vala"
			self->priv->total_x_delta = 1.0;
#line 424 "../src/Indicator.vala"
			break;
#line 1701 "Indicator.c"
		}
		default:
		{
#line 426 "../src/Indicator.vala"
			break;
#line 1707 "Indicator.c"
		}
	}
#line 429 "../src/Indicator.vala"
	if (fabs (self->priv->total_y_delta) > 0.5) {
#line 1712 "Indicator.c"
		gdouble _tmp5_ = 0.0;
#line 430 "../src/Indicator.vala"
		if (natural_scroll) {
#line 430 "../src/Indicator.vala"
			_tmp5_ = self->priv->total_y_delta;
#line 1718 "Indicator.c"
		} else {
#line 430 "../src/Indicator.vala"
			_tmp5_ = -self->priv->total_y_delta;
#line 1722 "Indicator.c"
		}
#line 430 "../src/Indicator.vala"
		_vala_dir = _tmp5_;
#line 1726 "Indicator.c"
	} else {
#line 431 "../src/Indicator.vala"
		if (fabs (self->priv->total_x_delta) > 0.5) {
#line 1730 "Indicator.c"
			gdouble _tmp6_ = 0.0;
#line 432 "../src/Indicator.vala"
			if (natural_scroll) {
#line 432 "../src/Indicator.vala"
				_tmp6_ = -self->priv->total_x_delta;
#line 1736 "Indicator.c"
			} else {
#line 432 "../src/Indicator.vala"
				_tmp6_ = self->priv->total_x_delta;
#line 1740 "Indicator.c"
			}
#line 432 "../src/Indicator.vala"
			_vala_dir = _tmp6_;
#line 1744 "Indicator.c"
		}
	}
#line 435 "../src/Indicator.vala"
	if (fabs (_vala_dir) > 0.0) {
#line 436 "../src/Indicator.vala"
		self->priv->total_y_delta = 0.0;
#line 437 "../src/Indicator.vala"
		self->priv->total_x_delta = 0.0;
#line 438 "../src/Indicator.vala"
		result = TRUE;
#line 438 "../src/Indicator.vala"
		if (dir) {
#line 438 "../src/Indicator.vala"
			*dir = _vala_dir;
#line 1759 "Indicator.c"
		}
#line 438 "../src/Indicator.vala"
		return result;
#line 1763 "Indicator.c"
	}
#line 441 "../src/Indicator.vala"
	result = FALSE;
#line 441 "../src/Indicator.vala"
	if (dir) {
#line 441 "../src/Indicator.vala"
		*dir = _vala_dir;
#line 1771 "Indicator.c"
	}
#line 441 "../src/Indicator.vala"
	return result;
#line 1775 "Indicator.c"
}

static void
sound_indicator_handle_change (SoundIndicator* self,
                               gdouble change,
                               gboolean is_mic)
{
	gdouble v = 0.0;
	gdouble new_v = 0.0;
	gint _tmp6_;
#line 444 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 447 "../src/Indicator.vala"
	if (is_mic) {
#line 1790 "Indicator.c"
		SoundServicesVolumeControlPulse* _tmp0_;
		gdouble _tmp1_;
		gdouble _tmp2_;
#line 448 "../src/Indicator.vala"
		_tmp0_ = self->priv->volume_control;
#line 448 "../src/Indicator.vala"
		_tmp1_ = sound_services_volume_control_get_mic_volume ((SoundServicesVolumeControl*) _tmp0_);
#line 448 "../src/Indicator.vala"
		_tmp2_ = _tmp1_;
#line 448 "../src/Indicator.vala"
		v = _tmp2_;
#line 1802 "Indicator.c"
	} else {
		SoundServicesVolumeControlPulse* _tmp3_;
		SoundServicesVolumeControlVolume* _tmp4_;
		SoundServicesVolumeControlVolume* _tmp5_;
#line 450 "../src/Indicator.vala"
		_tmp3_ = self->priv->volume_control;
#line 450 "../src/Indicator.vala"
		_tmp4_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp3_);
#line 450 "../src/Indicator.vala"
		_tmp5_ = _tmp4_;
#line 450 "../src/Indicator.vala"
		v = _tmp5_->volume;
#line 1815 "Indicator.c"
	}
#line 453 "../src/Indicator.vala"
	_tmp6_ = self->priv->_volume_step;
#line 453 "../src/Indicator.vala"
	new_v = CLAMP (v + ((((gdouble) _tmp6_) * change) / 100.0), 0.0, self->priv->max_volume);
#line 455 "../src/Indicator.vala"
	if (new_v == v) {
#line 457 "../src/Indicator.vala"
		return;
#line 1825 "Indicator.c"
	}
#line 460 "../src/Indicator.vala"
	if (is_mic) {
#line 1829 "Indicator.c"
		SoundServicesVolumeControlPulse* _tmp7_;
#line 461 "../src/Indicator.vala"
		_tmp7_ = self->priv->volume_control;
#line 461 "../src/Indicator.vala"
		sound_services_volume_control_set_mic_volume ((SoundServicesVolumeControl*) _tmp7_, new_v);
#line 1835 "Indicator.c"
	} else {
		SoundServicesVolumeControlVolume* vol = NULL;
		SoundServicesVolumeControlVolume* _tmp8_;
		SoundServicesVolumeControlVolume* _tmp9_;
		SoundServicesVolumeControlVolume* _tmp10_;
		SoundServicesVolumeControlPulse* _tmp11_;
		SoundServicesVolumeControlVolume* _tmp12_;
#line 463 "../src/Indicator.vala"
		_tmp8_ = sound_services_volume_control_volume_new ();
#line 463 "../src/Indicator.vala"
		vol = _tmp8_;
#line 464 "../src/Indicator.vala"
		_tmp9_ = vol;
#line 464 "../src/Indicator.vala"
		_tmp9_->reason = SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_USER_KEYPRESS;
#line 465 "../src/Indicator.vala"
		_tmp10_ = vol;
#line 465 "../src/Indicator.vala"
		_tmp10_->volume = new_v;
#line 466 "../src/Indicator.vala"
		_tmp11_ = self->priv->volume_control;
#line 466 "../src/Indicator.vala"
		_tmp12_ = vol;
#line 466 "../src/Indicator.vala"
		sound_services_volume_control_set_volume ((SoundServicesVolumeControl*) _tmp11_, _tmp12_);
#line 460 "../src/Indicator.vala"
		_g_object_unref0 (vol);
#line 1863 "Indicator.c"
	}
#line 469 "../src/Indicator.vala"
	sound_indicator_notify_change (self, is_mic);
#line 1867 "Indicator.c"
}

static void
sound_indicator_real_opened (WingpanelIndicator* base)
{
	SoundIndicator * self;
	SoundWidgetsPlayerList* _tmp0_;
	NotifyNotification* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 472 "../src/Indicator.vala"
	self = (SoundIndicator*) base;
#line 473 "../src/Indicator.vala"
	self->priv->open = TRUE;
#line 475 "../src/Indicator.vala"
	_tmp0_ = self->priv->mpris;
#line 475 "../src/Indicator.vala"
	sound_widgets_player_list_update_default_player (_tmp0_);
#line 477 "../src/Indicator.vala"
	_tmp1_ = self->priv->notification;
#line 477 "../src/Indicator.vala"
	if (_tmp1_ != NULL) {
#line 1889 "Indicator.c"
		{
			NotifyNotification* _tmp2_;
#line 479 "../src/Indicator.vala"
			_tmp2_ = self->priv->notification;
#line 479 "../src/Indicator.vala"
			notify_notification_close (_tmp2_, &_inner_error0_);
#line 479 "../src/Indicator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1898 "Indicator.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
#line 478 "../src/Indicator.vala"
			e = _inner_error0_;
#line 478 "../src/Indicator.vala"
			_inner_error0_ = NULL;
#line 481 "../src/Indicator.vala"
			_tmp3_ = e;
#line 481 "../src/Indicator.vala"
			_tmp4_ = _tmp3_->message;
#line 481 "../src/Indicator.vala"
			g_warning ("Indicator.vala:481: Unable to close sound notification: %s", _tmp4_);
#line 478 "../src/Indicator.vala"
			_g_error_free0 (e);
#line 1920 "Indicator.c"
		}
		__finally0:
#line 478 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 478 "../src/Indicator.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 478 "../src/Indicator.vala"
			g_clear_error (&_inner_error0_);
#line 478 "../src/Indicator.vala"
			return;
#line 1931 "Indicator.c"
		}
#line 484 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->notification);
#line 484 "../src/Indicator.vala"
		self->priv->notification = NULL;
#line 1937 "Indicator.c"
	}
}

static void
sound_indicator_real_closed (WingpanelIndicator* base)
{
	SoundIndicator * self;
#line 488 "../src/Indicator.vala"
	self = (SoundIndicator*) base;
#line 489 "../src/Indicator.vala"
	self->priv->open = FALSE;
#line 490 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->notification);
#line 490 "../src/Indicator.vala"
	self->priv->notification = NULL;
#line 1953 "Indicator.c"
}

static void
sound_indicator_show_settings (SoundIndicator* self)
{
	GError* _inner_error0_ = NULL;
#line 493 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 494 "../src/Indicator.vala"
	g_signal_emit_by_name ((WingpanelIndicator*) self, "close");
#line 1964 "Indicator.c"
	{
#line 497 "../src/Indicator.vala"
		g_app_info_launch_default_for_uri ("settings://sound", NULL, &_inner_error0_);
#line 497 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1970 "Indicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 496 "../src/Indicator.vala"
		e = _inner_error0_;
#line 496 "../src/Indicator.vala"
		_inner_error0_ = NULL;
#line 499 "../src/Indicator.vala"
		_tmp0_ = e;
#line 499 "../src/Indicator.vala"
		_tmp1_ = _tmp0_->message;
#line 499 "../src/Indicator.vala"
		g_warning ("Indicator.vala:499: %s\n", _tmp1_);
#line 496 "../src/Indicator.vala"
		_g_error_free0 (e);
#line 1992 "Indicator.c"
	}
	__finally0:
#line 496 "../src/Indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 496 "../src/Indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 496 "../src/Indicator.vala"
		g_clear_error (&_inner_error0_);
#line 496 "../src/Indicator.vala"
		return;
#line 2003 "Indicator.c"
	}
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 504 "../src/Indicator.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 504 "../src/Indicator.vala"
	return _data1_;
#line 2014 "Indicator.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 504 "../src/Indicator.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 2024 "Indicator.c"
		SoundIndicator* self;
#line 504 "../src/Indicator.vala"
		self = _data1_->self;
#line 504 "../src/Indicator.vala"
		_g_object_unref0 (self);
#line 504 "../src/Indicator.vala"
		g_slice_free (Block1Data, _data1_);
#line 2032 "Indicator.c"
	}
}

static gboolean
__lambda57_ (Block1Data* _data1_)
{
	SoundIndicator* self;
	gboolean notification_showing = FALSE;
	gboolean result;
#line 509 "../src/Indicator.vala"
	self = _data1_->self;
#line 510 "../src/Indicator.vala"
	notification_showing = FALSE;
#line 512 "../src/Indicator.vala"
	if (!self->priv->open) {
#line 513 "../src/Indicator.vala"
		notification_showing = sound_indicator_show_notification (self, _data1_->is_mic);
#line 2050 "Indicator.c"
	}
#line 518 "../src/Indicator.vala"
	if (!notification_showing) {
#line 2054 "Indicator.c"
		ca_proplist* props = NULL;
		ca_proplist* _tmp0_ = NULL;
		ca_proplist* _tmp1_;
		ca_proplist* _tmp2_;
		ca_context* _tmp3_;
		ca_proplist* _tmp4_;
#line 520 "../src/Indicator.vala"
		ca_proplist_create (&_tmp0_);
#line 520 "../src/Indicator.vala"
		_ca_proplist_destroy0 (props);
#line 520 "../src/Indicator.vala"
		props = _tmp0_;
#line 521 "../src/Indicator.vala"
		_tmp1_ = props;
#line 521 "../src/Indicator.vala"
		ca_proplist_sets (_tmp1_, CA_PROP_CANBERRA_CACHE_CONTROL, "volatile");
#line 522 "../src/Indicator.vala"
		_tmp2_ = props;
#line 522 "../src/Indicator.vala"
		ca_proplist_sets (_tmp2_, CA_PROP_EVENT_ID, "audio-volume-change");
#line 523 "../src/Indicator.vala"
		_tmp3_ = self->priv->ca_context;
#line 523 "../src/Indicator.vala"
		_tmp4_ = props;
#line 523 "../src/Indicator.vala"
		ca_context_play_full (_tmp3_, (guint32) 0, _tmp4_, NULL, NULL);
#line 518 "../src/Indicator.vala"
		_ca_proplist_destroy0 (props);
#line 2083 "Indicator.c"
	}
#line 526 "../src/Indicator.vala"
	self->priv->notify_timeout_id = (guint) 0;
#line 527 "../src/Indicator.vala"
	result = FALSE;
#line 527 "../src/Indicator.vala"
	return result;
#line 2091 "Indicator.c"
}

static gboolean
___lambda57__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda57_ (self);
#line 509 "../src/Indicator.vala"
	return result;
#line 2101 "Indicator.c"
}

static void
sound_indicator_notify_change (SoundIndicator* self,
                               gboolean is_mic)
{
	Block1Data* _data1_;
#line 504 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 504 "../src/Indicator.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 504 "../src/Indicator.vala"
	_data1_->_ref_count_ = 1;
#line 504 "../src/Indicator.vala"
	_data1_->self = g_object_ref (self);
#line 504 "../src/Indicator.vala"
	_data1_->is_mic = is_mic;
#line 505 "../src/Indicator.vala"
	if (self->priv->notify_timeout_id > ((guint) 0)) {
#line 506 "../src/Indicator.vala"
		block1_data_unref (_data1_);
#line 506 "../src/Indicator.vala"
		_data1_ = NULL;
#line 506 "../src/Indicator.vala"
		return;
#line 2127 "Indicator.c"
	}
#line 509 "../src/Indicator.vala"
	self->priv->notify_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 50, ___lambda57__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 504 "../src/Indicator.vala"
	block1_data_unref (_data1_);
#line 504 "../src/Indicator.vala"
	_data1_ = NULL;
#line 2135 "Indicator.c"
}

static gboolean
sound_indicator_show_notification (SoundIndicator* self,
                                   gboolean is_mic)
{
	NotifyNotification* _tmp0_;
	NotifyNotification* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 532 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 533 "../src/Indicator.vala"
	_tmp0_ = self->priv->notification;
#line 533 "../src/Indicator.vala"
	if (_tmp0_ == NULL) {
#line 2152 "Indicator.c"
		NotifyNotification* _tmp1_;
		NotifyNotification* _tmp2_;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
#line 534 "../src/Indicator.vala"
		_tmp1_ = notify_notification_new ("indicator-sound", "", "");
#line 534 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->notification);
#line 534 "../src/Indicator.vala"
		self->priv->notification = _tmp1_;
#line 535 "../src/Indicator.vala"
		_tmp2_ = self->priv->notification;
#line 535 "../src/Indicator.vala"
		_tmp3_ = g_variant_new_string ("indicator-sound");
#line 535 "../src/Indicator.vala"
		g_variant_ref_sink (_tmp3_);
#line 535 "../src/Indicator.vala"
		_tmp4_ = _tmp3_;
#line 535 "../src/Indicator.vala"
		notify_notification_set_hint (_tmp2_, "x-canonical-private-synchronous", _tmp4_);
#line 535 "../src/Indicator.vala"
		_g_variant_unref0 (_tmp4_);
#line 2175 "Indicator.c"
	}
#line 538 "../src/Indicator.vala"
	_tmp5_ = self->priv->notification;
#line 538 "../src/Indicator.vala"
	if (_tmp5_ != NULL) {
#line 2181 "Indicator.c"
		gchar* icon = NULL;
		NotifyNotification* _tmp20_;
		const gchar* _tmp21_;
		gint32 volume = 0;
		NotifyNotification* _tmp28_;
		GVariant* _tmp29_;
		GVariant* _tmp30_;
#line 541 "../src/Indicator.vala"
		if (is_mic) {
#line 2191 "Indicator.c"
			gboolean _tmp6_ = FALSE;
			SoundServicesVolumeControlPulse* _tmp7_;
			gdouble _tmp8_;
			gdouble _tmp9_;
#line 542 "../src/Indicator.vala"
			_tmp7_ = self->priv->volume_control;
#line 542 "../src/Indicator.vala"
			_tmp8_ = sound_services_volume_control_get_mic_volume ((SoundServicesVolumeControl*) _tmp7_);
#line 542 "../src/Indicator.vala"
			_tmp9_ = _tmp8_;
#line 542 "../src/Indicator.vala"
			if (_tmp9_ <= ((gdouble) 0)) {
#line 542 "../src/Indicator.vala"
				_tmp6_ = TRUE;
#line 2206 "Indicator.c"
			} else {
				SoundServicesVolumeControlPulse* _tmp10_;
				gboolean _tmp11_;
				gboolean _tmp12_;
#line 542 "../src/Indicator.vala"
				_tmp10_ = self->priv->volume_control;
#line 542 "../src/Indicator.vala"
				_tmp11_ = sound_services_volume_control_pulse_get_micMute (_tmp10_);
#line 542 "../src/Indicator.vala"
				_tmp12_ = _tmp11_;
#line 542 "../src/Indicator.vala"
				_tmp6_ = _tmp12_;
#line 2219 "Indicator.c"
			}
#line 542 "../src/Indicator.vala"
			if (_tmp6_) {
#line 2223 "Indicator.c"
				gchar* _tmp13_;
#line 543 "../src/Indicator.vala"
				_tmp13_ = g_strdup ("microphone-sensitivity-muted-symbolic");
#line 543 "../src/Indicator.vala"
				_g_free0 (icon);
#line 543 "../src/Indicator.vala"
				icon = _tmp13_;
#line 2231 "Indicator.c"
			} else {
				gchar* _tmp14_;
#line 545 "../src/Indicator.vala"
				_tmp14_ = g_strdup ("audio-input-microphone-symbolic");
#line 545 "../src/Indicator.vala"
				_g_free0 (icon);
#line 545 "../src/Indicator.vala"
				icon = _tmp14_;
#line 2240 "Indicator.c"
			}
		} else {
			SoundWidgetsScale* _tmp15_;
			GtkScale* _tmp16_;
			GtkScale* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
#line 548 "../src/Indicator.vala"
			_tmp15_ = self->priv->volume_scale;
#line 548 "../src/Indicator.vala"
			_tmp16_ = sound_widgets_scale_get_scale_widget (_tmp15_);
#line 548 "../src/Indicator.vala"
			_tmp17_ = _tmp16_;
#line 548 "../src/Indicator.vala"
			_tmp18_ = sound_indicator_get_volume_icon (self, gtk_range_get_value ((GtkRange*) _tmp17_));
#line 548 "../src/Indicator.vala"
			_tmp19_ = g_strdup (_tmp18_);
#line 548 "../src/Indicator.vala"
			_g_free0 (icon);
#line 548 "../src/Indicator.vala"
			icon = _tmp19_;
#line 2262 "Indicator.c"
		}
#line 551 "../src/Indicator.vala"
		_tmp20_ = self->priv->notification;
#line 551 "../src/Indicator.vala"
		_tmp21_ = icon;
#line 551 "../src/Indicator.vala"
		notify_notification_update (_tmp20_, "indicator-sound", "", _tmp21_);
#line 554 "../src/Indicator.vala"
		if (is_mic) {
#line 2272 "Indicator.c"
			SoundServicesVolumeControlPulse* _tmp22_;
			gdouble _tmp23_;
			gdouble _tmp24_;
#line 555 "../src/Indicator.vala"
			_tmp22_ = self->priv->volume_control;
#line 555 "../src/Indicator.vala"
			_tmp23_ = sound_services_volume_control_get_mic_volume ((SoundServicesVolumeControl*) _tmp22_);
#line 555 "../src/Indicator.vala"
			_tmp24_ = _tmp23_;
#line 555 "../src/Indicator.vala"
			volume = (gint32) round ((_tmp24_ / self->priv->max_volume) * 100.0);
#line 2284 "Indicator.c"
		} else {
			SoundServicesVolumeControlPulse* _tmp25_;
			SoundServicesVolumeControlVolume* _tmp26_;
			SoundServicesVolumeControlVolume* _tmp27_;
#line 557 "../src/Indicator.vala"
			_tmp25_ = self->priv->volume_control;
#line 557 "../src/Indicator.vala"
			_tmp26_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp25_);
#line 557 "../src/Indicator.vala"
			_tmp27_ = _tmp26_;
#line 557 "../src/Indicator.vala"
			volume = (gint32) round ((_tmp27_->volume / self->priv->max_volume) * 100.0);
#line 2297 "Indicator.c"
		}
#line 560 "../src/Indicator.vala"
		_tmp28_ = self->priv->notification;
#line 560 "../src/Indicator.vala"
		_tmp29_ = g_variant_new_int32 (volume);
#line 560 "../src/Indicator.vala"
		g_variant_ref_sink (_tmp29_);
#line 560 "../src/Indicator.vala"
		_tmp30_ = _tmp29_;
#line 560 "../src/Indicator.vala"
		notify_notification_set_hint (_tmp28_, "value", _tmp30_);
#line 560 "../src/Indicator.vala"
		_g_variant_unref0 (_tmp30_);
#line 2311 "Indicator.c"
		{
			NotifyNotification* _tmp31_;
#line 563 "../src/Indicator.vala"
			_tmp31_ = self->priv->notification;
#line 563 "../src/Indicator.vala"
			notify_notification_show (_tmp31_, &_inner_error0_);
#line 563 "../src/Indicator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2320 "Indicator.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp32_;
			const gchar* _tmp33_;
#line 562 "../src/Indicator.vala"
			e = _inner_error0_;
#line 562 "../src/Indicator.vala"
			_inner_error0_ = NULL;
#line 565 "../src/Indicator.vala"
			_tmp32_ = e;
#line 565 "../src/Indicator.vala"
			_tmp33_ = _tmp32_->message;
#line 565 "../src/Indicator.vala"
			g_warning ("Indicator.vala:565: Unable to show sound notification: %s", _tmp33_);
#line 566 "../src/Indicator.vala"
			_g_object_unref0 (self->priv->notification);
#line 566 "../src/Indicator.vala"
			self->priv->notification = NULL;
#line 567 "../src/Indicator.vala"
			result = FALSE;
#line 567 "../src/Indicator.vala"
			_g_error_free0 (e);
#line 567 "../src/Indicator.vala"
			_g_free0 (icon);
#line 567 "../src/Indicator.vala"
			return result;
#line 2352 "Indicator.c"
		}
		__finally0:
#line 562 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2357 "Indicator.c"
			gboolean _tmp34_ = FALSE;
#line 562 "../src/Indicator.vala"
			_g_free0 (icon);
#line 562 "../src/Indicator.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 562 "../src/Indicator.vala"
			g_clear_error (&_inner_error0_);
#line 562 "../src/Indicator.vala"
			return _tmp34_;
#line 2367 "Indicator.c"
		}
#line 538 "../src/Indicator.vala"
		_g_free0 (icon);
#line 2371 "Indicator.c"
	} else {
#line 570 "../src/Indicator.vala"
		result = FALSE;
#line 570 "../src/Indicator.vala"
		return result;
#line 2377 "Indicator.c"
	}
#line 573 "../src/Indicator.vala"
	result = TRUE;
#line 573 "../src/Indicator.vala"
	return result;
#line 2383 "Indicator.c"
}

static void
sound_indicator_update_tooltip (SoundIndicator* self)
{
	gdouble _tmp0_ = 0.0;
	SoundServicesVolumeControlPulse* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gchar* description = NULL;
	gchar* _tmp7_;
	const gchar* _tmp8_ = NULL;
	SoundServicesVolumeControlPulse* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	gchar* accel_label = NULL;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	DisplayWidget* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
#line 576 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 578 "../src/Indicator.vala"
	_tmp1_ = self->priv->volume_control;
#line 578 "../src/Indicator.vala"
	_tmp2_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp1_);
#line 578 "../src/Indicator.vala"
	_tmp3_ = _tmp2_;
#line 578 "../src/Indicator.vala"
	if (_tmp3_) {
#line 578 "../src/Indicator.vala"
		_tmp0_ = (gdouble) 0;
#line 2420 "Indicator.c"
	} else {
		SoundServicesVolumeControlPulse* _tmp4_;
		SoundServicesVolumeControlVolume* _tmp5_;
		SoundServicesVolumeControlVolume* _tmp6_;
#line 578 "../src/Indicator.vala"
		_tmp4_ = self->priv->volume_control;
#line 578 "../src/Indicator.vala"
		_tmp5_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp4_);
#line 578 "../src/Indicator.vala"
		_tmp6_ = _tmp5_;
#line 578 "../src/Indicator.vala"
		_tmp0_ = _tmp6_->volume * 100;
#line 2433 "Indicator.c"
	}
#line 577 "../src/Indicator.vala"
	_tmp7_ = g_strdup_printf (_ ("Volume: %.0f%%"), _tmp0_);
#line 577 "../src/Indicator.vala"
	description = _tmp7_;
#line 580 "../src/Indicator.vala"
	_tmp9_ = self->priv->volume_control;
#line 580 "../src/Indicator.vala"
	_tmp10_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp9_);
#line 580 "../src/Indicator.vala"
	_tmp11_ = _tmp10_;
#line 580 "../src/Indicator.vala"
	if (_tmp11_) {
#line 580 "../src/Indicator.vala"
		_tmp8_ = _ ("Middle-click to unmute");
#line 2449 "Indicator.c"
	} else {
#line 580 "../src/Indicator.vala"
		_tmp8_ = _ ("Middle-click to mute");
#line 2453 "Indicator.c"
	}
#line 580 "../src/Indicator.vala"
	_tmp12_ = g_strdup (_tmp8_);
#line 580 "../src/Indicator.vala"
	accel_label = _tmp12_;
#line 582 "../src/Indicator.vala"
	_tmp13_ = accel_label;
#line 582 "../src/Indicator.vala"
	_tmp14_ = g_strdup_printf (GRANITE_TOOLTIP_SECONDARY_TEXT_MARKUP, _tmp13_);
#line 582 "../src/Indicator.vala"
	_g_free0 (accel_label);
#line 582 "../src/Indicator.vala"
	accel_label = _tmp14_;
#line 583 "../src/Indicator.vala"
	_tmp15_ = self->priv->display_widget;
#line 583 "../src/Indicator.vala"
	_tmp16_ = description;
#line 583 "../src/Indicator.vala"
	_tmp17_ = accel_label;
#line 583 "../src/Indicator.vala"
	_tmp18_ = g_strdup_printf ("%s\n%s", _tmp16_, _tmp17_);
#line 583 "../src/Indicator.vala"
	_tmp19_ = _tmp18_;
#line 583 "../src/Indicator.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp15_, _tmp19_);
#line 583 "../src/Indicator.vala"
	_g_free0 (_tmp19_);
#line 576 "../src/Indicator.vala"
	_g_free0 (accel_label);
#line 576 "../src/Indicator.vala"
	_g_free0 (description);
#line 2485 "Indicator.c"
}

gboolean
sound_indicator_get_natural_scroll_touchpad (SoundIndicator* self)
{
	gboolean result;
#line 19 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 19 "../src/Indicator.vala"
	result = self->priv->_natural_scroll_touchpad;
#line 19 "../src/Indicator.vala"
	return result;
#line 2498 "Indicator.c"
}

void
sound_indicator_set_natural_scroll_touchpad (SoundIndicator* self,
                                             gboolean value)
{
	gboolean old_value;
#line 19 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/Indicator.vala"
	old_value = sound_indicator_get_natural_scroll_touchpad (self);
#line 19 "../src/Indicator.vala"
	if (old_value != value) {
#line 19 "../src/Indicator.vala"
		self->priv->_natural_scroll_touchpad = value;
#line 19 "../src/Indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_indicator_properties[SOUND_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY]);
#line 2516 "Indicator.c"
	}
}

gboolean
sound_indicator_get_natural_scroll_mouse (SoundIndicator* self)
{
	gboolean result;
#line 20 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 20 "../src/Indicator.vala"
	result = self->priv->_natural_scroll_mouse;
#line 20 "../src/Indicator.vala"
	return result;
#line 2530 "Indicator.c"
}

void
sound_indicator_set_natural_scroll_mouse (SoundIndicator* self,
                                          gboolean value)
{
	gboolean old_value;
#line 20 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/Indicator.vala"
	old_value = sound_indicator_get_natural_scroll_mouse (self);
#line 20 "../src/Indicator.vala"
	if (old_value != value) {
#line 20 "../src/Indicator.vala"
		self->priv->_natural_scroll_mouse = value;
#line 20 "../src/Indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_indicator_properties[SOUND_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY]);
#line 2548 "Indicator.c"
	}
}

gint
sound_indicator_get_volume_step (SoundIndicator* self)
{
	gint result;
#line 21 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 21 "../src/Indicator.vala"
	result = self->priv->_volume_step;
#line 21 "../src/Indicator.vala"
	return result;
#line 2562 "Indicator.c"
}

void
sound_indicator_set_volume_step (SoundIndicator* self,
                                 gint value)
{
	gint old_value;
#line 21 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Indicator.vala"
	old_value = sound_indicator_get_volume_step (self);
#line 21 "../src/Indicator.vala"
	if (old_value != value) {
#line 21 "../src/Indicator.vala"
		self->priv->_volume_step = value;
#line 21 "../src/Indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_indicator_properties[SOUND_INDICATOR_VOLUME_STEP_PROPERTY]);
#line 2580 "Indicator.c"
	}
}

static void
_sound_indicator_on_volume_change_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
#line 76 "../src/Indicator.vala"
	sound_indicator_on_volume_change ((SoundIndicator*) self);
#line 2591 "Indicator.c"
}

static void
_sound_indicator_on_mic_volume_change_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
#line 77 "../src/Indicator.vala"
	sound_indicator_on_mic_volume_change ((SoundIndicator*) self);
#line 2601 "Indicator.c"
}

static void
_sound_indicator_on_mute_change_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
#line 78 "../src/Indicator.vala"
	sound_indicator_on_mute_change ((SoundIndicator*) self);
#line 2611 "Indicator.c"
}

static void
_sound_indicator_on_mic_mute_change_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 79 "../src/Indicator.vala"
	sound_indicator_on_mic_mute_change ((SoundIndicator*) self);
#line 2621 "Indicator.c"
}

static void
_sound_indicator_on_is_playing_change_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
#line 80 "../src/Indicator.vala"
	sound_indicator_on_is_playing_change ((SoundIndicator*) self);
#line 2631 "Indicator.c"
}

static void
_sound_indicator_update_mic_visibility_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
#line 81 "../src/Indicator.vala"
	sound_indicator_update_mic_visibility ((SoundIndicator*) self);
#line 2641 "Indicator.c"
}

static void
_sound_indicator_update_tooltip_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
#line 84 "../src/Indicator.vala"
	sound_indicator_update_tooltip ((SoundIndicator*) self);
#line 2651 "Indicator.c"
}

static void
_sound_indicator_set_max_volume_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
#line 96 "../src/Indicator.vala"
	sound_indicator_set_max_volume ((SoundIndicator*) self);
#line 2661 "Indicator.c"
}

static void
_sound_indicator___lambda67_ (SoundIndicator* self,
                              GdkEventButton* e)
{
#line 100 "../src/Indicator.vala"
	g_return_if_fail (e != NULL);
#line 101 "../src/Indicator.vala"
	if (e->button == ((guint) GDK_BUTTON_MIDDLE)) {
#line 2672 "Indicator.c"
		SoundServicesVolumeControlPulse* _tmp0_;
#line 102 "../src/Indicator.vala"
		_tmp0_ = self->priv->volume_control;
#line 102 "../src/Indicator.vala"
		sound_services_volume_control_pulse_toggle_mute (_tmp0_);
#line 2678 "Indicator.c"
	}
}

static void
__sound_indicator___lambda67__display_widget_volume_press_event (DisplayWidget* _sender,
                                                                 GdkEventButton* e,
                                                                 gpointer self)
{
#line 100 "../src/Indicator.vala"
	_sound_indicator___lambda67_ ((SoundIndicator*) self, e);
#line 2689 "Indicator.c"
}

static void
_sound_indicator___lambda68_ (SoundIndicator* self,
                              GdkEventButton* e)
{
#line 106 "../src/Indicator.vala"
	g_return_if_fail (e != NULL);
#line 107 "../src/Indicator.vala"
	if (e->button == ((guint) GDK_BUTTON_MIDDLE)) {
#line 2700 "Indicator.c"
		SoundServicesVolumeControlPulse* _tmp0_;
#line 108 "../src/Indicator.vala"
		_tmp0_ = self->priv->volume_control;
#line 108 "../src/Indicator.vala"
		sound_services_volume_control_pulse_toggle_mic_mute (_tmp0_);
#line 2706 "Indicator.c"
	}
}

static void
__sound_indicator___lambda68__display_widget_mic_press_event (DisplayWidget* _sender,
                                                              GdkEventButton* e,
                                                              gpointer self)
{
#line 106 "../src/Indicator.vala"
	_sound_indicator___lambda68_ ((SoundIndicator*) self, e);
#line 2717 "Indicator.c"
}

static void
_sound_indicator_on_volume_icon_scroll_event_display_widget_volume_scroll_event (DisplayWidget* _sender,
                                                                                 GdkEventScroll* e,
                                                                                 gpointer self)
{
#line 114 "../src/Indicator.vala"
	sound_indicator_on_volume_icon_scroll_event ((SoundIndicator*) self, e);
#line 2727 "Indicator.c"
}

static void
_sound_indicator_on_mic_icon_scroll_event_display_widget_mic_scroll_event (DisplayWidget* _sender,
                                                                           GdkEventScroll* e,
                                                                           gpointer self)
{
#line 115 "../src/Indicator.vala"
	sound_indicator_on_mic_icon_scroll_event ((SoundIndicator*) self, e);
#line 2737 "Indicator.c"
}

static GObject *
sound_indicator_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundIndicator * self;
	GSettings* touchpad_settings = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* mouse_settings = NULL;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* gnome_settings = NULL;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GtkIconTheme* _tmp6_;
	DisplayWidget* _tmp7_;
	SoundServicesVolumeControlPulse* _tmp8_;
	SoundServicesVolumeControlPulse* _tmp9_;
	SoundServicesVolumeControlPulse* _tmp10_;
	SoundServicesVolumeControlPulse* _tmp11_;
	SoundServicesVolumeControlPulse* _tmp12_;
	SoundServicesVolumeControlPulse* _tmp13_;
	SoundServicesVolumeControlPulse* _tmp14_;
	SoundServicesVolumeControlPulse* _tmp15_;
	SoundServicesVolumeControlPulse* _tmp16_;
	SoundWidgetsDeviceManagerWidget* _tmp17_ = NULL;
	SoundWidgetsDeviceManagerWidget* _tmp18_ = NULL;
	GSettings* _tmp19_;
	gchar* locale = NULL;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	DisplayWidget* _tmp22_;
	DisplayWidget* _tmp23_;
	DisplayWidget* _tmp24_;
	SoundServicesVolumeControlPulse* _tmp25_;
	SoundServicesVolumeControlVolume* _tmp26_;
	SoundServicesVolumeControlVolume* _tmp27_;
	const gchar* _tmp28_;
	DisplayWidget* _tmp29_;
	DisplayWidget* _tmp30_;
	SoundWidgetsScale* _tmp31_;
	SoundWidgetsScale* _tmp32_;
	ca_context* _tmp33_;
	ca_context* _tmp34_;
	const gchar* _tmp35_;
	ca_context* _tmp36_;
#line 56 "../src/Indicator.vala"
	parent_class = G_OBJECT_CLASS (sound_indicator_parent_class);
#line 56 "../src/Indicator.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 56 "../src/Indicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_INDICATOR, SoundIndicator);
#line 57 "../src/Indicator.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 58 "../src/Indicator.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 60 "../src/Indicator.vala"
	_tmp0_ = g_settings_new ("org.gnome.desktop.peripherals.touchpad");
#line 60 "../src/Indicator.vala"
	touchpad_settings = _tmp0_;
#line 61 "../src/Indicator.vala"
	_tmp1_ = touchpad_settings;
#line 61 "../src/Indicator.vala"
	g_settings_bind (_tmp1_, "natural-scroll", (GObject*) self, "natural-scroll-touchpad", G_SETTINGS_BIND_DEFAULT);
#line 62 "../src/Indicator.vala"
	_tmp2_ = g_settings_new ("org.gnome.desktop.peripherals.mouse");
#line 62 "../src/Indicator.vala"
	mouse_settings = _tmp2_;
#line 63 "../src/Indicator.vala"
	_tmp3_ = mouse_settings;
#line 63 "../src/Indicator.vala"
	g_settings_bind (_tmp3_, "natural-scroll", (GObject*) self, "natural-scroll-mouse", G_SETTINGS_BIND_DEFAULT);
#line 64 "../src/Indicator.vala"
	_tmp4_ = g_settings_new ("org.gnome.settings-daemon.plugins.media-keys");
#line 64 "../src/Indicator.vala"
	gnome_settings = _tmp4_;
#line 65 "../src/Indicator.vala"
	_tmp5_ = gnome_settings;
#line 65 "../src/Indicator.vala"
	g_settings_bind (_tmp5_, "volume-step", (GObject*) self, "volume-step", G_SETTINGS_BIND_DEFAULT);
#line 67 "../src/Indicator.vala"
	wingpanel_indicator_set_visible ((WingpanelIndicator*) self, TRUE);
#line 71 "../src/Indicator.vala"
	_tmp6_ = gtk_icon_theme_get_default ();
#line 71 "../src/Indicator.vala"
	gtk_icon_theme_add_resource_path (_tmp6_, "/org/elementary/wingpanel/icons");
#line 73 "../src/Indicator.vala"
	_tmp7_ = display_widget_new ();
#line 73 "../src/Indicator.vala"
	g_object_ref_sink (_tmp7_);
#line 73 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->display_widget);
#line 73 "../src/Indicator.vala"
	self->priv->display_widget = _tmp7_;
#line 75 "../src/Indicator.vala"
	_tmp8_ = sound_services_volume_control_pulse_new ();
#line 75 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->volume_control);
#line 75 "../src/Indicator.vala"
	self->priv->volume_control = _tmp8_;
#line 76 "../src/Indicator.vala"
	_tmp9_ = self->priv->volume_control;
#line 76 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp9_, "notify::volume", (GCallback) _sound_indicator_on_volume_change_g_object_notify, self, 0);
#line 77 "../src/Indicator.vala"
	_tmp10_ = self->priv->volume_control;
#line 77 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp10_, "notify::mic-volume", (GCallback) _sound_indicator_on_mic_volume_change_g_object_notify, self, 0);
#line 78 "../src/Indicator.vala"
	_tmp11_ = self->priv->volume_control;
#line 78 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp11_, "notify::mute", (GCallback) _sound_indicator_on_mute_change_g_object_notify, self, 0);
#line 79 "../src/Indicator.vala"
	_tmp12_ = self->priv->volume_control;
#line 79 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp12_, "notify::micMute", (GCallback) _sound_indicator_on_mic_mute_change_g_object_notify, self, 0);
#line 80 "../src/Indicator.vala"
	_tmp13_ = self->priv->volume_control;
#line 80 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp13_, "notify::is-playing", (GCallback) _sound_indicator_on_is_playing_change_g_object_notify, self, 0);
#line 81 "../src/Indicator.vala"
	_tmp14_ = self->priv->volume_control;
#line 81 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp14_, "notify::is-listening", (GCallback) _sound_indicator_update_mic_visibility_g_object_notify, self, 0);
#line 84 "../src/Indicator.vala"
	_tmp15_ = self->priv->volume_control;
#line 84 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp15_, "notify::volume", (GCallback) _sound_indicator_update_tooltip_g_object_notify, self, 0);
#line 85 "../src/Indicator.vala"
	_tmp16_ = self->priv->volume_control;
#line 85 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp16_, "notify::mute", (GCallback) _sound_indicator_update_tooltip_g_object_notify, self, 0);
#line 87 "../src/Indicator.vala"
	_tmp17_ = sound_widgets_device_manager_widget_new ();
#line 87 "../src/Indicator.vala"
	_tmp17_->is_input_manager = FALSE;
#line 87 "../src/Indicator.vala"
	g_object_ref_sink (_tmp17_);
#line 87 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->output_device_manager);
#line 87 "../src/Indicator.vala"
	self->priv->output_device_manager = _tmp17_;
#line 90 "../src/Indicator.vala"
	_tmp18_ = sound_widgets_device_manager_widget_new ();
#line 90 "../src/Indicator.vala"
	_tmp18_->is_input_manager = TRUE;
#line 90 "../src/Indicator.vala"
	g_object_ref_sink (_tmp18_);
#line 90 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->input_device_manager);
#line 90 "../src/Indicator.vala"
	self->priv->input_device_manager = _tmp18_;
#line 94 "../src/Indicator.vala"
	notify_init ("wingpanel-indicator-sound");
#line 96 "../src/Indicator.vala"
	_tmp19_ = sound_indicator_settings;
#line 96 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp19_, "notify::max-volume", (GCallback) _sound_indicator_set_max_volume_g_object_notify, self, 0);
#line 98 "../src/Indicator.vala"
	_tmp20_ = setlocale (LC_MESSAGES, NULL);
#line 98 "../src/Indicator.vala"
	_tmp21_ = g_strdup (_tmp20_);
#line 98 "../src/Indicator.vala"
	locale = _tmp21_;
#line 100 "../src/Indicator.vala"
	_tmp22_ = self->priv->display_widget;
#line 100 "../src/Indicator.vala"
	g_signal_connect_object (_tmp22_, "volume-press-event", (GCallback) __sound_indicator___lambda67__display_widget_volume_press_event, self, 0);
#line 106 "../src/Indicator.vala"
	_tmp23_ = self->priv->display_widget;
#line 106 "../src/Indicator.vala"
	g_signal_connect_object (_tmp23_, "mic-press-event", (GCallback) __sound_indicator___lambda68__display_widget_mic_press_event, self, 0);
#line 112 "../src/Indicator.vala"
	_tmp24_ = self->priv->display_widget;
#line 112 "../src/Indicator.vala"
	_tmp25_ = self->priv->volume_control;
#line 112 "../src/Indicator.vala"
	_tmp26_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp25_);
#line 112 "../src/Indicator.vala"
	_tmp27_ = _tmp26_;
#line 112 "../src/Indicator.vala"
	_tmp28_ = sound_indicator_get_volume_icon (self, _tmp27_->volume);
#line 112 "../src/Indicator.vala"
	display_widget_set_icon_name (_tmp24_, _tmp28_);
#line 114 "../src/Indicator.vala"
	_tmp29_ = self->priv->display_widget;
#line 114 "../src/Indicator.vala"
	g_signal_connect_object (_tmp29_, "volume-scroll-event", (GCallback) _sound_indicator_on_volume_icon_scroll_event_display_widget_volume_scroll_event, self, G_CONNECT_AFTER);
#line 115 "../src/Indicator.vala"
	_tmp30_ = self->priv->display_widget;
#line 115 "../src/Indicator.vala"
	g_signal_connect_object (_tmp30_, "mic-scroll-event", (GCallback) _sound_indicator_on_mic_icon_scroll_event_display_widget_mic_scroll_event, self, G_CONNECT_AFTER);
#line 117 "../src/Indicator.vala"
	_tmp31_ = sound_widgets_scale_new ("audio-volume-high-symbolic", TRUE, 0.0, self->priv->max_volume, 0.01);
#line 117 "../src/Indicator.vala"
	g_object_ref_sink (_tmp31_);
#line 117 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->volume_scale);
#line 117 "../src/Indicator.vala"
	self->priv->volume_scale = _tmp31_;
#line 119 "../src/Indicator.vala"
	_tmp32_ = sound_widgets_scale_new ("indicator-microphone-symbolic", TRUE, 0.0, 1.0, 0.01);
#line 119 "../src/Indicator.vala"
	g_object_ref_sink (_tmp32_);
#line 119 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->mic_scale);
#line 119 "../src/Indicator.vala"
	self->priv->mic_scale = _tmp32_;
#line 121 "../src/Indicator.vala"
	_tmp33_ = ca_gtk_context_get ();
#line 121 "../src/Indicator.vala"
	self->priv->ca_context = _tmp33_;
#line 122 "../src/Indicator.vala"
	_tmp34_ = self->priv->ca_context;
#line 122 "../src/Indicator.vala"
	_tmp35_ = locale;
#line 122 "../src/Indicator.vala"
	ca_context_change_props (_tmp34_, CA_PROP_APPLICATION_NAME, "indicator-sound", CA_PROP_APPLICATION_ID, "wingpanel-indicator-sound", CA_PROP_APPLICATION_NAME, "start-here", CA_PROP_APPLICATION_LANGUAGE, _tmp35_, NULL, NULL);
#line 127 "../src/Indicator.vala"
	_tmp36_ = self->priv->ca_context;
#line 127 "../src/Indicator.vala"
	ca_context_open (_tmp36_);
#line 56 "../src/Indicator.vala"
	_g_free0 (locale);
#line 56 "../src/Indicator.vala"
	_g_object_unref0 (gnome_settings);
#line 56 "../src/Indicator.vala"
	_g_object_unref0 (mouse_settings);
#line 56 "../src/Indicator.vala"
	_g_object_unref0 (touchpad_settings);
#line 56 "../src/Indicator.vala"
	return obj;
#line 2975 "Indicator.c"
}

static void
sound_indicator_class_init (SoundIndicatorClass * klass,
                            gpointer klass_data)
{
	GSettings* _tmp0_;
#line 18 "../src/Indicator.vala"
	sound_indicator_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/Indicator.vala"
	g_type_class_adjust_private_offset (klass, &SoundIndicator_private_offset);
#line 18 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->get_display_widget = (GtkWidget* (*) (WingpanelIndicator*)) sound_indicator_real_get_display_widget;
#line 18 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->get_widget = (GtkWidget* (*) (WingpanelIndicator*)) sound_indicator_real_get_widget;
#line 18 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->opened = (void (*) (WingpanelIndicator*)) sound_indicator_real_opened;
#line 18 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->closed = (void (*) (WingpanelIndicator*)) sound_indicator_real_closed;
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_indicator_get_property;
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_indicator_set_property;
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->constructor = sound_indicator_constructor;
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_indicator_finalize;
#line 18 "../src/Indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY, sound_indicator_properties[SOUND_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY] = g_param_spec_boolean ("natural-scroll-touchpad", "natural-scroll-touchpad", "natural-scroll-touchpad", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/Indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY, sound_indicator_properties[SOUND_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY] = g_param_spec_boolean ("natural-scroll-mouse", "natural-scroll-mouse", "natural-scroll-mouse", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/Indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_INDICATOR_VOLUME_STEP_PROPERTY, sound_indicator_properties[SOUND_INDICATOR_VOLUME_STEP_PROPERTY] = g_param_spec_int ("volume-step", "volume-step", "volume-step", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 53 "../src/Indicator.vala"
	_tmp0_ = g_settings_new ("io.elementary.desktop.wingpanel.sound");
#line 53 "../src/Indicator.vala"
	_g_object_unref0 (sound_indicator_settings);
#line 53 "../src/Indicator.vala"
	sound_indicator_settings = _tmp0_;
#line 3015 "Indicator.c"
}

static void
sound_indicator_instance_init (SoundIndicator * self,
                               gpointer klass)
{
#line 18 "../src/Indicator.vala"
	self->priv = sound_indicator_get_instance_private (self);
#line 34 "../src/Indicator.vala"
	self->priv->open = FALSE;
#line 35 "../src/Indicator.vala"
	self->priv->mute_blocks_sound = FALSE;
#line 38 "../src/Indicator.vala"
	self->priv->max_volume = 1.0;
#line 40 "../src/Indicator.vala"
	self->priv->ca_context = NULL;
#line 43 "../src/Indicator.vala"
	self->priv->total_x_delta = (gdouble) 0;
#line 44 "../src/Indicator.vala"
	self->priv->total_y_delta = (gdouble) 0;
#line 503 "../src/Indicator.vala"
	self->priv->notify_timeout_id = (guint) 0;
#line 3038 "Indicator.c"
}

static void
sound_indicator_finalize (GObject * obj)
{
	SoundIndicator * self;
#line 18 "../src/Indicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_INDICATOR, SoundIndicator);
#line 131 "../src/Indicator.vala"
	if (self->priv->sound_was_blocked_timeout_id > ((guint) 0)) {
#line 132 "../src/Indicator.vala"
		g_source_remove (self->priv->sound_was_blocked_timeout_id);
#line 3051 "Indicator.c"
	}
#line 135 "../src/Indicator.vala"
	if (self->priv->notify_timeout_id > ((guint) 0)) {
#line 136 "../src/Indicator.vala"
		g_source_remove (self->priv->notify_timeout_id);
#line 3057 "Indicator.c"
	}
#line 23 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->display_widget);
#line 24 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->main_box);
#line 25 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->mpris);
#line 26 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->volume_scale);
#line 27 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->mic_scale);
#line 28 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->output_device_manager);
#line 29 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->input_device_manager);
#line 30 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->mic_separator);
#line 31 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->notification);
#line 32 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->volume_control);
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (sound_indicator_parent_class)->finalize (obj);
#line 3081 "Indicator.c"
}

static GType
sound_indicator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundIndicator), 0, (GInstanceInitFunc) sound_indicator_instance_init, NULL };
	GType sound_indicator_type_id;
	sound_indicator_type_id = g_type_register_static (WINGPANEL_TYPE_INDICATOR, "SoundIndicator", &g_define_type_info, 0);
	SoundIndicator_private_offset = g_type_add_instance_private (sound_indicator_type_id, sizeof (SoundIndicatorPrivate));
	return sound_indicator_type_id;
}

GType
sound_indicator_get_type (void)
{
	static volatile gsize sound_indicator_type_id__once = 0;
	if (g_once_init_enter (&sound_indicator_type_id__once)) {
		GType sound_indicator_type_id;
		sound_indicator_type_id = sound_indicator_get_type_once ();
		g_once_init_leave (&sound_indicator_type_id__once, sound_indicator_type_id);
	}
	return sound_indicator_type_id__once;
}

static void
_vala_sound_indicator_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	SoundIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_INDICATOR, SoundIndicator);
#line 18 "../src/Indicator.vala"
	switch (property_id) {
#line 18 "../src/Indicator.vala"
		case SOUND_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY:
#line 18 "../src/Indicator.vala"
		g_value_set_boolean (value, sound_indicator_get_natural_scroll_touchpad (self));
#line 18 "../src/Indicator.vala"
		break;
#line 18 "../src/Indicator.vala"
		case SOUND_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY:
#line 18 "../src/Indicator.vala"
		g_value_set_boolean (value, sound_indicator_get_natural_scroll_mouse (self));
#line 18 "../src/Indicator.vala"
		break;
#line 18 "../src/Indicator.vala"
		case SOUND_INDICATOR_VOLUME_STEP_PROPERTY:
#line 18 "../src/Indicator.vala"
		g_value_set_int (value, sound_indicator_get_volume_step (self));
#line 18 "../src/Indicator.vala"
		break;
#line 3134 "Indicator.c"
		default:
#line 18 "../src/Indicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Indicator.vala"
		break;
#line 3140 "Indicator.c"
	}
}

static void
_vala_sound_indicator_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	SoundIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_INDICATOR, SoundIndicator);
#line 18 "../src/Indicator.vala"
	switch (property_id) {
#line 18 "../src/Indicator.vala"
		case SOUND_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY:
#line 18 "../src/Indicator.vala"
		sound_indicator_set_natural_scroll_touchpad (self, g_value_get_boolean (value));
#line 18 "../src/Indicator.vala"
		break;
#line 18 "../src/Indicator.vala"
		case SOUND_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY:
#line 18 "../src/Indicator.vala"
		sound_indicator_set_natural_scroll_mouse (self, g_value_get_boolean (value));
#line 18 "../src/Indicator.vala"
		break;
#line 18 "../src/Indicator.vala"
		case SOUND_INDICATOR_VOLUME_STEP_PROPERTY:
#line 18 "../src/Indicator.vala"
		sound_indicator_set_volume_step (self, g_value_get_int (value));
#line 18 "../src/Indicator.vala"
		break;
#line 3172 "Indicator.c"
		default:
#line 18 "../src/Indicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Indicator.vala"
		break;
#line 3178 "Indicator.c"
	}
}

WingpanelIndicator*
get_indicator (GModule* module,
               WingpanelIndicatorManagerServerType server_type)
{
	SoundIndicator* indicator = NULL;
	SoundIndicator* _tmp0_;
	WingpanelIndicator* result;
#line 587 "../src/Indicator.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 588 "../src/Indicator.vala"
	g_debug ("Indicator.vala:588: Activating Sound Indicator");
#line 590 "../src/Indicator.vala"
	if (server_type != WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_SESSION) {
#line 591 "../src/Indicator.vala"
		result = NULL;
#line 591 "../src/Indicator.vala"
		return result;
#line 3199 "Indicator.c"
	}
#line 594 "../src/Indicator.vala"
	_tmp0_ = sound_indicator_new ();
#line 594 "../src/Indicator.vala"
	indicator = _tmp0_;
#line 595 "../src/Indicator.vala"
	result = (WingpanelIndicator*) indicator;
#line 595 "../src/Indicator.vala"
	return result;
#line 3209 "Indicator.c"
}

